<?php
namespace Teknisa\COC\Controllers;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;

class CusteioMenuGridReport extends \Zeedhi\Framework\Controller\Report {

    protected $birtStrategy;
    protected $CusteioMenuGridController;
    public function __construct(ReportService $reportService, $CusteioMenuGridController, $birtStrategy) {
        $this->CusteioMenuGridController = $CusteioMenuGridController;
        $this->birtStrategy = $birtStrategy;
        parent::__construct($reportService);
    }

    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        if (isset($row['REPORTFORMAT']) && $row['REPORTFORMAT']){
          $this->birtStrategy->setReportFormat($row['REPORTFORMAT']);
        }
        if($row['REPORTNAME'] === 'COC03610') {
            $cdfilial        = $row['CDFILIAL'];
            $cdcia           = $row['CDCIA'];
            $cdmancia        = $row['CDMANCIA'];
            $datacusto	     = $row['DTCUSTOMAN'];
            $tipocusto	     = $row['TIPOCUSTO'];
            $nrservicoclasse = $row['NRSERVICOCLASSE'];
            $dssubgru        = $row['DSSUBGRU'];
            $cdciclo         = $row['CDCICLO'];
            $nritairvision   = $row['NRITAIRVISION'];
            $cdoperador	     = $row['CDOPERADOR'];
            $nrorg		     = $row['NRORG'];
            $row['CDCONTROLE'] = $this->CusteioMenuGridController->PROD_MANUALCIAM($cdfilial,$cdcia,$cdmancia,$datacusto,$tipocusto,$cdoperador,$nrorg, $response, $nrservicoclasse, $dssubgru, $cdciclo, $nritairvision); //$origem
        }
    }

    protected $reportMapping = array (
        'COC03610' => array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
              "CDFILIAL"        => "CDFILIAL",
              "CDCIA"           => "CDCIA",
              "CDMANCIA"        => "CDMANCIA",
              "CDCONTROLE"      => "CDCONTROLE",
              "DTCUSTOMAN"      => "DTCUSTOMAN",
              "TIPOCUSTO"       => "TIPOCUSTO",
              "CDINDICE"        => "CDINDICE",
              "NRORG"           => "NRORG"
            )
        ),
        'COC03611' => array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
              "CDFILIAL"        => "CDFILIAL",
              "CDCIA"           => "CDCIA",
              "CDMANCIA"        => "CDMANCIA",
              "QTPAXREF"        => "QTPAXREF",
              "DATAREF"         => "DATA",
              "TIPOCUSTO"       => "TIPOCUSTO",
              "CDINDICE"        => "CDINDICE" ,
              "NRSERVICOCLASSE" => "NRSERVICOCLASSE" ,
              "DSSUBGRU"        => "DSSUBGRU" ,
              "CDCICLO"         => "CDCICLO" ,
              "NRITAIRVISION"   => "NRITAIRVISION" ,
              "INFLACAO"        => "INFLACAO",
              "TDTVGSUMA"       => "TDTVGSUMA",
              "NRORG"           => "NRORG"
            )
        ),
        'COC03612' => array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
              "CDFILIAL"        => "CDFILIAL",
              "CDCIA"           => "CDCIA",
              "CDMANCIA"        => "CDMANCIA",
              "QTPAXREF"        => "QTPAXREF",
              "DATAREF"         => "DATA",
              "TIPOCUSTO"       => "TIPOCUSTO",
              "CDINDICE"        => "CDINDICE" ,
              "NRSERVICOCLASSE" => "NRSERVICOCLASSE" ,
              "DSSUBGRU"        => "DSSUBGRU" ,
              "CDCICLO"         => "CDCICLO" ,
              "NRITAIRVISION"   => "NRITAIRVISION" ,
              "INFLACAO"        => "INFLACAO",
              "TDTVGSUMA"       => "TDTVGSUMA",
              "NRORG"           => "NRORG"
            )
        ),
        'COC03613' => array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
              "CDFILIAL"        => "CDFILIAL",
              "CDCIA"           => "CDCIA",
              "CDMANCIA"        => "CDMANCIA",
              "NRSERVICOCLASSE" => "NRSERVICOCLASSE",
              "DSSUBGRU"        => "DSSUBGRU",
              "CDCICLO"         => "CDCICLO",
              "NRITAIRVISION"   => "NRITAIRVISION",
              "TDTVGSUMA"       => "TDTVGSUMA"
            )
        )
    );

}