<?php

namespace Teknisa\COC\Controllers;

// use Teknisa\GER\Utilities\Environment;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
// use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Message;
use Teknisa\COC\Controllers;
use Teknisa\GER\Services;

/**
* 
*/
class DuplicacaoController extends \Teknisa\GER\Controllers\TeknisaCrud {

	protected $receita;
	protected $variacaoReceita;
	protected $composicaoVariacaoProduto;
	protected $composicaoVariacaoReceita;
	protected $modoprepVariacao;
	protected $unidadeVariacao;
	protected $newCode;
    protected $environment;
	protected $parameterBag;
	
	function __construct($crudService, $environment, $dataSourceManager, $parameterBag, $receita, $variacaoReceita, $composicaoVariacaoProduto, $composicaoVariacaoReceita, $modoprepVariacao, $unidadeVariacao, $newCode)
	{
        $this->crudService                  = $crudService;
        $this->environment 					= $environment;
        $this->dataSourceManager            = $dataSourceManager;
        $this->parameterBag 				= $parameterBag;
		$this->receita 						= $receita;
		$this->variacaoReceita 				= $variacaoReceita;
		$this->composicaoVariacaoProduto 	= $composicaoVariacaoProduto;
		$this->composicaoVariacaoReceita 	= $composicaoVariacaoReceita;
		$this->modoprepVariacao 			= $modoprepVariacao;
		$this->unidadeVariacao 				= $unidadeVariacao;
		$this->newCode 						= $newCode;
		// parent::__construct($dataSourceManager, $environment, $parameterBag);
	}

	public function duplicaReceita(DTO\Request $request, DTO\Response $response){

		$duplicada = array();
		$parameters = $request->getRow();
		$cdReceita = $parameters['CDRECEITA'];
		$newFilterArray = array(
			array( 
				"columnName" => "CDRECEITA",
				"operator" => "=",
				"value" => $parameters['CDRECEITA']
			)
		);
		$parameters['__is_new'] = true;
		unset($parameters['CDRECEITA']);
		$this->receita->salvaNovaReceita($request, $response);
		$receitaDuplicada = $request->getRow();
		$arrayReceita = (array) $receitaDuplicada;
		array_push($duplicada, $arrayReceita);

		$newFilterCriteria = new FilterCriteria(null , $newFilterArray);
		$newRequest = new DTO\Request\Filter($newFilterCriteria, '', '', '');

		$this->variacaoReceita->find($newRequest, $response);

		$dataSetVariacoes = $response->getDataSets();
		$variacoesOriginais = array_pop($dataSetVariacoes)->getRows();
		
		$nrVariacaoRecList = array_column($variacoesOriginais, "NRVARIACAOREC");

		foreach ($variacoesOriginais as &$row) {
			$row['CDRECEITA'] = $duplicada[0]['CDRECEITA'];
			$row['__is_new'] = true;
		}

		$newDataSet = new DataSet(null , $variacoesOriginais);

		$newRequestVariacao = new DTO\Request\DataSet($newDataSet, '', '', '');
		$this->variacaoReceita->save($newRequestVariacao, $response);

		foreach ($nrVariacaoRecList as $nrVariacaoRec) {
			$newFilterArrayComp = array(
				array( 
					"columnName" => "CDRECEITA",
					"operator" => "=",
					"value" => $cdReceita
				),
				array(
					"columnName" => "NRVARIACAOREC",
					"operator" => "=",
					"value" => $nrVariacaoRec
				)
			);
			$newFilterCriteriaComp = new FilterCriteria(null , $newFilterArrayComp);
			$newRequestComp = new DTO\Request\Filter($newFilterCriteriaComp, '', '', '');

			//Copia produtos
			$this->composicaoVariacaoProduto->save($this->requestParaCopia($newRequestComp, $response, 'proreceitam', $duplicada), $response);

			//Copia receitas
			$this->composicaoVariacaoReceita->save($this->requestParaCopia($newRequestComp, $response, 'subreceitam', $duplicada), $response);

			//Copia modo de preparo
			$this->modoprepVariacao->save($this->requestParaCopia($newRequestComp, $response, 'modpreprecm', $duplicada), $response);
		}
		

	}

	public function requestParaCopia($request, $response, $datasource, $receitaDuplicada){
		$itens = $this->genericFind($request, $response, $datasource);
		foreach ($itens as &$row) {
			$row['CDRECEITA'] = $receitaDuplicada[0]['CDRECEITA'];
			$row['__is_new'] = true;
		}
		$newDataSet = new DataSet(null , $itens);

		$newRequest = new DTO\Request\DataSet($newDataSet, '', '', '');
		return $newRequest;
	}

	public function duplicaVariacao(DTO\Request $request, DTO\Response $response){

		$parameters = $request->getRow();
		$newFilterArray = array(
			array( 
				"columnName" => "CDRECEITA",
				"operator" => "=",
				"value" => $parameters['CDRECEITA']
			),
			array(
				"columnName" => "NRVARIACAOREC",
				"operator" => "=",
				"value" => $parameters['NRVARIACAOREC']
			)
		);

		$parameters['__is_new'] = true;

		$this->variacaoReceita->novaVariacao($request, $response);

		$variacaoDuplicada = $response->getDataSets();
		
		$newFilterCriteria = new FilterCriteria(null , $newFilterArray);
		$newRequest = new DTO\Request\Filter($newFilterCriteria, '', '', '');

		$this->duplicaCompProd($this->genericFind($newRequest, $response, 'proreceitam'), $variacaoDuplicada, $response);
		$this->duplicaCompRec($this->genericFind($newRequest, $response, 'subreceitam'), $variacaoDuplicada, $response);
		$this->duplicaModoprepRecProd($this->genericFind($newRequest, $response, 'modpreprecm'), $variacaoDuplicada, $response);

	}

	public function duplicaCompProd($composicaoVariacaoProdutoOriginal, $variacaoDuplicada, $response){

		$itensDuplicados = [];
		$currentTime = $this->environment->getCurrentTime()->format("d/m/Y H:i:s");
		$camposVariacaoDuplicada = $variacaoDuplicada[0]->getRows();

		foreach ($composicaoVariacaoProdutoOriginal as $row) {
			array_push($itensDuplicados, array(
					"CDPRODUTO"=> $row['CDPRODUTO'],
					"CDRECEITA"=> $camposVariacaoDuplicada[0]['CDRECEITA'] ,
					"NRVARIACAOREC"=> $camposVariacaoDuplicada[0]['NRVARIACAOREC'] ,
					"QTPRODREC"=> $row['QTPRODREC'] ,
					"NRORDPREC"=> $row['NRORDPREC'] ,
					"SGGRUPORECFLEX"=> $row['SGGRUPORECFLEX'] ,
					"DTINCLUSAO"=> $currentTime,
					"__is_new"=> true
				));
		}

		$newDataSet = new DataSet(null , $itensDuplicados);

		$newRequest = new DTO\Request\DataSet($newDataSet, '', '', '');

		$this->composicaoVariacaoProduto->save($newRequest, $response);

	}

	public function duplicaCompRec($composicaoVariacaoReceitaOriginal, $variacaoDuplicada, $response){

		$itensDuplicados = [];
		$currentTime = $this->environment->getCurrentTime()->format("d/m/Y H:i:s");
		$camposVariacaoDuplicada = $variacaoDuplicada[0]->getRows();

		foreach ($composicaoVariacaoReceitaOriginal as $row) {
			array_push($itensDuplicados, array(
					"CDSUBRECEITA"=> $row['CDSUBRECEITA'],
					"CDRECEITA"=> $camposVariacaoDuplicada[0]['CDRECEITA'] ,
					"NRVARIACAOREC"=> $camposVariacaoDuplicada[0]['NRVARIACAOREC'] ,
					"QTRENDSUBREC"=> $row['QTRENDSUBREC'] ,
					"NRORDSUBREC"=> $row['NRORDSUBREC'] ,
					"DTINCLUSAO"=> $currentTime,
					"__is_new"=> true
				));
		}

		$newDataSet = new DataSet(null , $itensDuplicados);

		$newRequest = new DTO\Request\DataSet($newDataSet, '', '', '');

		$this->composicaoVariacaoReceita->save($newRequest, $response);

	}

	public function duplicaModoprepRecProd($modoprepVariacaoOriginal, $variacaoDuplicada, $response){

		$itensDuplicados = [];
		$currentTime = $this->environment->getCurrentTime()->format("d/m/Y H:i:s");
		$camposVariacaoDuplicada = $variacaoDuplicada[0]->getRows();

		foreach ($modoprepVariacaoOriginal as $row) {
			array_push($itensDuplicados, array(
					"CDRECEITA"=> $camposVariacaoDuplicada[0]['CDRECEITA'] ,
					"NRVARIACAOREC"=> $camposVariacaoDuplicada[0]['NRVARIACAOREC'] ,
					"DSMPREPRECM"=> $row['DSMPREPRECM'] ,
					"DTINCLUSAO"=> $currentTime,
					"__is_new"=> true
				));
		}

		$newDataSet = new DataSet(null , $itensDuplicados);

		$newRequest = new DTO\Request\DataSet($newDataSet, '', '', '');

		$this->modoprepVariacao->save($newRequest, $response);

	}

	public function genericFind(DTO\Request\Filter $request, DTO\Response $response, $dataSourceName){
		$filterCriteria = $request->getFilterCriteria();
        //adiciona condição que filtra automaticamente pela NRORG logada
        $filterCriteria->addCondition("NRORG", "=", $this->environment->getNrOrgTrab());
		$filterCriteria->setDataSourceName($dataSourceName);
        $newFilterCriteria = $this->populateParameterBag($filterCriteria, $this->parameterBagColumns);
        $combinacao = $this->dataSourceManager->findBy($newFilterCriteria);
		return $combinacao;
	}

    protected function processConditionValue($condition) {
        return $condition['value'];
    }

    public function populateParameterBag(FilterCriteria $filterCriteria, $parameterBagColumns) {

        $conditions = array();

        foreach ($filterCriteria->getConditions() as $condition) {
            $columnName = $condition['columnName'];
            if (in_array($columnName, $parameterBagColumns)) {
                $this->parameterBag->set($columnName, $this->processConditionValue($condition));
            } else {
                $conditions[] = $condition;
            }
        }

        $newFilterCriteria = new FilterCriteria(
            $filterCriteria->getDataSourceName(),
            $conditions,
            $filterCriteria->getPage(),
            $filterCriteria->getPageSize()
        );

        return $newFilterCriteria;
    }

}