<?php

namespace Teknisa\COC\Controllers;

use Teknisa\GER\Utilities\Environment;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;

class FichaTecnicaController extends \Teknisa\GER\Controllers\TeknisaCrud {

	protected $dataSourceName = '';
	private $subgrupoArray = '';

	public function getSubgruTree($request, $response){
		$dataSet = $request->getDataSet()->getRows();
		$this->subgrupoArray = '';

		for ($i=0; $i < sizeof($dataSet); $i++) {
			$this->subgrupoArray = $this->subgrupoArray.$dataSet[$i]['CDSUBGRU'].'-'.$dataSet[$i]['NRSEQSUBGRUSEMAM'].'_';
			$this->getFilhos($dataSet[$i]);
		}

		$response->addDataSet(new DataSet("subgrutree", array(array('SUBGRUPO' => $this->subgrupoArray))));
	}

	private function getFilhos($subgrupoPai){
		$conditions = array(
			array(
				'columnName' => 'CDFILIAL',
				'operator' => '=',
				'value' => $subgrupoPai['CDFILIAL']
			),
			array(
				'columnName' => 'CDCIA',
				'operator' => '=',
				'value' => $subgrupoPai['CDCIA']
			),
			array(
				'columnName' => 'CDMANCIA',
				'operator' => '=',
				'value' => $subgrupoPai['CDMANCIA']
			),
			array(
				'columnName' => 'NRSERVICOCIAFILI',
				'operator' => '=',
				'value' => $subgrupoPai['NRSERVICOCIAFILI']
			),
			array(
				'columnName' => 'CDCLASSE',
				'operator' => '=',
				'value' => $subgrupoPai['CDCLASSE']
			),
			array(
				'columnName' => 'CDSUBGRUPRIN',
				'operator' => '=',
				'value' => $subgrupoPai['CDSUBGRU']
			),
			array(
				'columnName' => 'NRSEQSUBGRUSEMAMPRIN',
				'operator' => '=',
				'value' => $subgrupoPai['NRSEQSUBGRUSEMAM']
			),
			array(
				'columnName' => 'CDCICLO',
				'operator' => '=',
				'value' => $subgrupoPai['CDCICLO']
			),
			array(
				'columnName' => 'NRORG',
				'operator' => '=',
				'value' => $subgrupoPai['NRORG']
			)
		);

		$subgrupoFilho = $this->crudService->getFilteredDataSet('subgruprincipalmenu', $conditions)->getRows();
		for ($i=0; $i < sizeof($subgrupoFilho); $i++) {
			$this->subgrupoArray = $this->subgrupoArray.$subgrupoFilho[$i]['CDSUBGRU'].'-'.$subgrupoFilho[$i]['NRSEQSUBGRUSEMAM'].'_';
			$this->getFilhos($subgrupoFilho[$i]);
		}
	}
}