<?php

namespace Teknisa\COC\Controllers;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;

class FrequenciaCicloServicoAnual extends \Teknisa\GER\Controllers\TeknisaCrud {

	protected $dataSourceName = 'frcicloserm_anual';
    protected $parameterBagColumns = array("DTINICIAL", "DTFINAL", "NRORG", "CDFILIAL", "CDCIA", "CDTRECHO", "NRVOO", "NRSERVICOCIAFILI");

    public function __construct($crudService, $parameterBag,  $environment, $dataSourceManager) {
        $this->crudService = $crudService;
        $this->parameterBag=$parameterBag;
        $this->environment=$environment;
        $this->dataSourceManager = $dataSourceManager;
    }

    public function save(DTO\Request $request, DTO\Response $response){
    	$this->dataSourceName = 'frcicloserm';
    	$this->parameterBagColumns = array();
		$rows = array();
		$request = $this->crudService->buildDataSetIfRow($request, $this->dataSourceName);
		$dataSet = $request->getDataSet();
        $rows = $dataSet->getRows();
		foreach ($request->getDataSet()->getRows() as $row) {
			$condition = array(
	            array(
	                "value" => $row['CDFILIAL'],
	                "operator" => "=",
	                "columnName" => "CDFILIAL"
	            ),
	            array(
	                "value" => $row['CDCIA'],
	                "operator" => "=",
	                "columnName" => "CDCIA"
	            ),
	            array(
	            	"value" => $row['DTCICLOSER'],
	                "operator" => "=",
	                "columnName" => "DTCICLOSER"
	            ),
	            array(
	                "value" => $row['NRORG'],
	                "operator" => "=",
	                "columnName" => "NRORG"
	            ),
	            array( 
	            	"value" => $row['NRVOO'],
	            	"operator" => "=",
	            	"columnName" => "NRVOO"
	            ),
	            array(
	            	"value" => $row['CDTRECHO'],
	            	"operator" => "=",
	            	"columnName" => "CDTRECHO"
	            ),
	            array(
	            	"value" => $row['NRSERVICOCIAFILI'],
	            	"operator" => "=",
	            	"columnName" => "NRSERVICOCIAFILI"
	            ),
	        	array(
	            	"value" => $row['CDCLASSE'],
	            	"operator" => "=",
	            	"columnName" => "CDCLASSE"
	            )
	        );
	        $filterCriteria = new FilterCriteria($this->dataSourceName, $condition);
	        $newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $this->parameterBagColumns);
	        $newdataSet = $this->dataSourceManager->findBy($newFilterCriteria);
	        $newRows = $newdataSet->getRows();
	        if(!empty($newRows)){
	        	$row['__is_new'] = false;
	        }
	        $row['changed'] = true;
	    }
    	parent::save($request, $response);
    }
    
    public function deleteCiclo(DTO\Request $request, DTO\Response $response) {
        $this->dataSourceName = 'frcicloserm_ciclo';
        try {
            $request = $this->crudService->buildDataSetIfRow($request, $this->dataSourceName);
            $dataSet = $request->getDataSet();
            $dataSet->setDataSourceName($this->dataSourceName);
            $this->crudService->delete($response, $dataSet);
        } catch (\Exception $e) {
            $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), 500));
        }
    }

}