<?php

namespace Teknisa\COC\Controllers;

use Teknisa\GER\Utilities\Environment;
use Teknisa\GER\Services\CrudService;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\Remote\FileUploader\Server;

class ImportacaoProporcaoVariavelController {

    const TABELA_PRECO = 1;
    const GRUPO_MANUAL = 2;
    const CONFIGURA_SERVICO = 3;
    const TABELA_PRECO_PROP_V = 4;
    const TABELA_PRECO_NM_PRECO = 'PROPRECOSEM';
    const TABELA_PRECO_NM_PROP = 'PROPORCAOPRECO';

    protected $environment;
    protected $connection;
    protected $crudService;

    protected $id;
    protected $data;
    protected $file;
    protected $fileArray;
    protected $cdfilial;
    protected $cdcia;
    protected $nrtabpreco;
    protected $nrservicociafili;
    protected $cdclasse;
    protected $cdciclo;
    protected $nrseqpreco;
    protected $cdmancia;
    protected $cdsubgru;
    protected $nrseqsubgrusemam;
    protected $nrvoo;
    protected $cdtrecho;
    protected $cdoperador;
    protected $nrorg;
    protected $sysdate;
    protected $de;
    protected $ate;
    protected $valor;
    protected $valor2;

    public function __construct($environment, $connection, $crudService) {
        $this->environment = $environment;
        $this->connection = $connection;
        $this->crudService = $crudService;
    }


    private function insereRegistroTabelaPreco($TABLE) {
        if($TABLE == self::TABELA_PRECO_NM_PRECO){
            $sql = "INSERT INTO PROPRECOSEM(CDFILIAL, CDCIA, NRTABPRECO, NRSERVICOCIAFILI, CDCLASSE, CDCICLO, NRSEQPRECO, QTPAXINICIAL, QTPAXFINAL, VRPRESERVPRO, VRPRESERVDPRO, NRORG, NRORGINCLUSAO, NRORGULTATU, CDOPERINCLUSAO, CDOPERULTATU, DTINCLUSAO, DTULTATU, IDATIVO) VALUES (:CDFILIAL, :CDCIA, :NRTABPRECO, :NRSERVICOCIAFILI, :CDCLASSE, :CDCICLO, :NRSEQPRECO, :DE, :ATE, :VALOR, :VALOR2, :NRORG, :NRORG, :NRORG, :CDOPERADOR, :CDOPERADOR, :NOW, :NOW, 'S')";
            $stmt = $this->connection->prepare($sql);
            $stmt->execute(array(
                'CDFILIAL' => $this->cdfilial,
                'CDCIA' => $this->cdcia,
                'NRTABPRECO' => $this->nrtabpreco,
                'NRSERVICOCIAFILI' => $this->nrservicociafili,
                'CDCLASSE' => $this->cdclasse,
                'CDCICLO' => $this->cdciclo,
                'NRSEQPRECO' => $this->nrseqpreco,
                'DE' => $this->de,
                'ATE' => $this->ate,
                'VALOR' => str_replace(',', '.', $this->valor),
                'VALOR2' => str_replace(',', '.', $this->valor2),
                'NRORG' => $this->nrorg,
                'CDOPERADOR' => $this->cdoperador,
                'NOW' => $this->sysdate
            ));
        } else if($TABLE == self::TABELA_PRECO_NM_PROP){
            $sql = "INSERT INTO PROPORCAOPRECO(CDFILIAL, CDCIA, NRTABPRECO, NRSERVICOCIAFILI, CDCLASSE, CDCICLO, NRSEQPRECO, QTPAXDE, QTPAXATE, QTSERVICO, NRORG, NRORGINCLUSAO, NRORGULTATU, CDOPERINCLUSAO, CDOPERULTATU, DTINCLUSAO, DTULTATU, IDATIVO) VALUES (:CDFILIAL, :CDCIA, :NRTABPRECO, :NRSERVICOCIAFILI, :CDCLASSE, :CDCICLO, :NRSEQPRECO, :DE, :ATE, :VALOR, :NRORG, :NRORG, :NRORG, :CDOPERADOR, :CDOPERADOR, :NOW, :NOW, 'S')";
            $stmt = $this->connection->prepare($sql);
            $stmt->execute(array(
                'CDFILIAL' => $this->cdfilial,
                'CDCIA' => $this->cdcia,
                'NRTABPRECO' => $this->nrtabpreco,
                'NRSERVICOCIAFILI' => $this->nrservicociafili,
                'CDCLASSE' => $this->cdclasse,
                'CDCICLO' => $this->cdciclo,
                'NRSEQPRECO' => $this->nrseqpreco,
                'DE' => $this->de,
                'ATE' => $this->ate,
                'VALOR' => str_replace(',', '.', $this->valor),
                'NRORG' => $this->nrorg,
                'CDOPERADOR' => $this->cdoperador,
                'NOW' => $this->sysdate
            ));
        }
    }

    private function insereRegistroGrupoManual() {
        $sql = "INSERT INTO PROPSUBGRUSE(CDFILIAL, CDCIA, CDMANCIA, NRSERVICOCIAFILI, CDCLASSE, CDSUBGRU, NRSEQSUBGRUSEMAM, QTPAXDE, QTPAXATE, QTSUBGRUPO, NRORG, NRORGINCLUSAO, NRORGULTATU, CDOPERINCLUSAO, CDOPERULTATU, DTINCLUSAO, DTULTATU, IDATIVO) VALUES (:CDFILIAL, :CDCIA, :CDMANCIA, :NRSERVICOCIAFILI, :CDCLASSE, :CDSUBGRU, :NRSEQSUBGRUSEMAM, :DE, :ATE, :VALOR, :NRORG, :NRORG, :NRORG, :CDOPERADOR, :CDOPERADOR, :NOW, :NOW, 'S')";
        $stmt = $this->connection->prepare($sql);
        $stmt->execute(array(
            'CDFILIAL' => $this->cdfilial,
            'CDCIA' => $this->cdcia,
            'CDMANCIA' => $this->cdmancia,
            'NRSERVICOCIAFILI' => $this->nrservicociafili,
            'CDCLASSE' => $this->cdclasse,
            'CDSUBGRU' => $this->cdsubgru,
            'NRSEQSUBGRUSEMAM' => $this->nrseqsubgrusemam,
            'DE' => $this->de,
            'ATE' => $this->ate,
            'VALOR' => str_replace(',', '.', $this->valor),
            'NRORG' => $this->nrorg,
            'CDOPERADOR' => $this->cdoperador,
            'NOW' => $this->sysdate
        ));
    }

    private function insereRegistroConfServico() {
        $sql = "INSERT INTO PROPSERVICOM(CDFILIAL, CDCIA, NRVOO, CDTRECHO, NRSERVICOCIAFILI, CDCLASSE, CDCICLO, QTPAXDE, QTPAXATE, QTSERVICO, NRORG, NRORGINCLUSAO, NRORGULTATU, CDOPERINCLUSAO, CDOPERULTATU, DTINCLUSAO, DTULTATU, IDATIVO) VALUES (:CDFILIAL, :CDCIA, :NRVOO, :CDTRECHO, :NRSERVICOCIAFILI, :CDCLASSE, :CDCICLO, :DE, :ATE, :VALOR, :NRORG, :NRORG, :NRORG, :CDOPERADOR, :CDOPERADOR, :NOW, :NOW, 'S')";
        $stmt = $this->connection->prepare($sql);
        $stmt->execute(array(
            'CDFILIAL' => $this->cdfilial,
            'CDCIA' => $this->cdcia,
            'NRVOO' => $this->nrvoo,
            'CDTRECHO' => $this->cdtrecho,
            'NRSERVICOCIAFILI' => $this->nrservicociafili,
            'CDCLASSE' => $this->cdclasse,
            'CDCICLO' => $this->cdciclo,
            'DE' => $this->de,
            'ATE' => $this->ate,
            'VALOR' => str_replace(',', '.', $this->valor),
            'NRORG' => $this->nrorg,
            'CDOPERADOR' => $this->cdoperador,
            'NOW' => $this->sysdate
        ));
    }

    private function removeRegistroTabelaPreco($TABLE) {
        $sql = "DELETE FROM $TABLE WHERE CDFILIAL = :CDFILIAL AND CDCIA = :CDCIA AND NRTABPRECO = :NRTABPRECO AND NRSERVICOCIAFILI = :NRSERVICOCIAFILI AND CDCLASSE = :CDCLASSE AND CDCICLO = :CDCICLO AND NRSEQPRECO = :NRSEQPRECO";
        $stmt = $this->connection->prepare($sql);
        $stmt->execute(array(
            'CDFILIAL' => $this->cdfilial,
            'CDCIA' => $this->cdcia,
            'NRTABPRECO' => $this->nrtabpreco,
            'NRSERVICOCIAFILI' => $this->nrservicociafili,
            'CDCLASSE' => $this->cdclasse,
            'CDCICLO' => $this->cdciclo,
            'NRSEQPRECO' => $this->nrseqpreco
        ));
    }

    private function removeRegistroGrupoManual() {
        $sql = 'DELETE FROM PROPSUBGRUSE WHERE CDFILIAL = :CDFILIAL AND CDCIA = :CDCIA AND CDMANCIA = :CDMANCIA AND NRSERVICOCIAFILI = :NRSERVICOCIAFILI AND CDCLASSE = :CDCLASSE    AND CDSUBGRU = :CDSUBGRU AND NRSEQSUBGRUSEMAM = :NRSEQSUBGRUSEMAM';
        $stmt = $this->connection->prepare($sql);
        $stmt->execute(array(
            'CDFILIAL' => $this->cdfilial,
            'CDCIA' => $this->cdcia,
            'CDMANCIA' => $this->cdmancia,
            'NRSERVICOCIAFILI' => $this->nrservicociafili,
            'CDCLASSE' => $this->cdclasse,
            'CDSUBGRU' => $this->cdsubgru,
            'NRSEQSUBGRUSEMAM' => $this->nrseqsubgrusemam
        ));
    }

    private function removeRegistroConfServico() {
        $sql = 'DELETE FROM PROPSERVICOM WHERE CDFILIAL = :CDFILIAL AND CDCIA = :CDCIA AND NRVOO = :NRVOO AND CDTRECHO = :CDTRECHO AND NRSERVICOCIAFILI = :NRSERVICOCIAFILI AND CDCLASSE = :CDCLASSE AND CDCICLO = :CDCICLO';
        $stmt = $this->connection->prepare($sql);
        $stmt->execute(array(
            'CDFILIAL' => $this->cdfilial,
            'CDCIA' => $this->cdcia,
            'NRVOO' => $this->nrvoo,
            'CDTRECHO' => $this->cdtrecho,
            'NRSERVICOCIAFILI' => $this->nrservicociafili,
            'CDCLASSE' => $this->cdclasse,
            'CDCICLO' => $this->cdciclo
        ));
    }

    private function confereValoresTabelaPreco($TABLE) {
        if($TABLE == self::TABELA_PRECO_NM_PRECO)
            $sql = "SELECT QTPAXINICIAL, QTPAXFINAL FROM $TABLE WHERE CDFILIAL = :CDFILIAL AND CDCIA = :CDCIA AND NRTABPRECO = :NRTABPRECO AND NRSERVICOCIAFILI = :NRSERVICOCIAFILI AND CDCLASSE = :CDCLASSE AND CDCICLO = :CDCICLO AND NRSEQPRECO = :NRSEQPRECO AND((:DE BETWEEN QTPAXINICIAL AND QTPAXFINAL) OR (:ATE BETWEEN QTPAXINICIAL AND QTPAXFINAL) OR (QTPAXINICIAL BETWEEN :DE AND :ATE) OR (QTPAXFINAL BETWEEN :DE AND :ATE))";
        else
            $sql = "SELECT QTPAXDE, QTPAXATE FROM $TABLE WHERE CDFILIAL = :CDFILIAL AND CDCIA = :CDCIA AND NRTABPRECO = :NRTABPRECO AND NRSERVICOCIAFILI = :NRSERVICOCIAFILI AND CDCLASSE = :CDCLASSE AND CDCICLO = :CDCICLO AND NRSEQPRECO = :NRSEQPRECO AND((:DE BETWEEN QTPAXDE AND QTPAXATE) OR (:ATE BETWEEN QTPAXDE AND QTPAXATE) OR (QTPAXDE BETWEEN :DE AND :ATE) OR (QTPAXATE BETWEEN :DE AND :ATE))";
        $stmt = $this->connection->prepare($sql);
        $stmt->execute(array(
            'CDFILIAL' => $this->cdfilial,
            'CDCIA' => $this->cdcia,
            'NRTABPRECO' => $this->nrtabpreco,
            'NRSERVICOCIAFILI' => $this->nrservicociafili,
            'CDCLASSE' => $this->cdclasse,
            'CDCICLO' => $this->cdciclo,
            'NRSEQPRECO' => $this->nrseqpreco,
            'DE' => $this->de,
            'ATE' => $this->ate
        ));


        $result = $stmt->fetch(\PDO::FETCH_ASSOC);

        if ($result){
            $de = "";
            $ate = "";
            if($TABLE == self::TABELA_PRECO_NM_PRECO){
                $de = $result["QTPAXINICIAL"];
                $ate = $result["QTPAXFINAL"];
            }
            else{
                $de = $result["QTPAXDE"];
                $ate = $result["QTPAXATE"];
            }
            throw new \Exception("COC21004_QTPAX_INV" . "#_#" . $this->de . "#_#" . $this->ate . "#_#" . $de . "#_#" . $ate);
        }
            

    }

    private function confereValoresGrupoManual() {
        $sql = 'SELECT QTPAXDE, QTPAXATE AS EXISTE_DADOS FROM PROPSUBGRUSE WHERE CDFILIAL = :CDFILIAL AND CDCIA = :CDCIA AND CDMANCIA = :CDMANCIA AND NRSERVICOCIAFILI = :NRSERVICOCIAFILI AND CDCLASSE = :CDCLASSE AND CDSUBGRU = :CDSUBGRU AND NRSEQSUBGRUSEMAM = :NRSEQSUBGRUSEMAM AND((:DE BETWEEN QTPAXDE AND QTPAXATE) OR (:ATE BETWEEN QTPAXDE AND QTPAXATE) OR (QTPAXDE BETWEEN :DE AND :ATE) OR (QTPAXATE BETWEEN :DE AND :ATE))';
        $stmt = $this->connection->prepare($sql);
        $stmt->execute(array(
            'CDFILIAL' => $this->cdfilial,
            'CDCIA' => $this->cdcia,
            'CDMANCIA' => $this->cdmancia,
            'NRSERVICOCIAFILI' => $this->nrservicociafili,
            'CDCLASSE' => $this->cdclasse,
            'CDSUBGRU' => $this->cdsubgru,
            'NRSEQSUBGRUSEMAM' => $this->nrseqsubgrusemam,
            'DE' => $this->de,
            'ATE' => $this->ate
        ));
        $result = $stmt->fetch(\PDO::FETCH_ASSOC);

        if ($result){
            $de = $result["QTPAXDE"];
            $ate = $result["QTPAXATE"];
            throw new \Exception("COC21004_QTPAX_INV" . "#_#" . $this->de . "#_#" . $this->ate . "#_#" . $de . "#_#" . $ate);
        }
    }

    private function confereValoresConfServico() {
        $sql = 'SELECT 1 AS EXISTE_DADOS FROM PROPSERVICOM WHERE CDFILIAL = :CDFILIAL AND CDCIA = :CDCIA AND NRVOO = :NRVOO AND CDTRECHO = :CDTRECHO AND NRSERVICOCIAFILI = :NRSERVICOCIAFILI AND CDCLASSE = :CDCLASSE AND CDCICLO = :CDCICLO AND((:DE BETWEEN QTPAXDE AND QTPAXATE) OR (:ATE BETWEEN QTPAXDE AND QTPAXATE) OR (QTPAXDE BETWEEN :DE AND :ATE) OR (QTPAXATE BETWEEN :DE AND :ATE))';
        $stmt = $this->connection->prepare($sql);
        $stmt->execute(array(
            'CDFILIAL' => $this->cdfilial,
            'CDCIA' => $this->cdcia,
            'NRVOO' => $this->nrvoo,
            'CDTRECHO' => $this->cdtrecho,
            'NRSERVICOCIAFILI' => $this->nrservicociafili,
            'CDCLASSE' => $this->cdclasse,
            'CDCICLO' => $this->cdciclo,
            'DE' => $this->de,
            'ATE' => $this->ate
        ));
        $result = $stmt->fetch(\PDO::FETCH_ASSOC);

        if ($result)
            $response->setError(new Error('O arquivo de importação inváldo. Verifique a quantidade de passageiros.', 500));
    }

    private function configuraTabelaPreco($response) {

        if(count($this->fileArray)==0){
            $response->setError(new Error("COC21004_ARQ_VAZIO", 500));
        } else {
            if(!strpos($this->fileArray[0], ";")){
                $response->setError(new Error("COC21004_SEP_INV", 500));
            } else {
                if (count((explode(";",$this->fileArray[0]))) != 4) {
                    $response->setError(new Error("COC21004_QT_COL_INV", 500));
                } else {
                    if($this->verificaArquivo($this->fileArray)){
                        $this->removeRegistroTabelaPreco(self::TABELA_PRECO_NM_PRECO);
                        for( $i=0; $i < count($this->fileArray); $i++) {
                            try{
                                $lineArray = explode(";",$this->fileArray[$i]);
                                $this->de = $lineArray[0];
                                $this->ate = $lineArray[1];
                                $this->valor = str_replace(',', '.', $lineArray[2]);
                                $this->valor2 = str_replace(',', '.', $lineArray[3]);
                                $this->confereValoresTabelaPreco(self::TABELA_PRECO_NM_PRECO);
                                $this->insereRegistroTabelaPreco(self::TABELA_PRECO_NM_PRECO);
                            } catch(\Exception $e){
                                throw new \Exception($e->getMessage(), 500);
                            }
                        }
                    }else {
                       throw new \Exception("COC21004_EXISTE_SOBREPOSICAO", 500);
                    }
                }
            }
        }
    }

    private function verificaArquivo($file){
        $permiteSave=0;
        for($key=0; $key<count($file); $key++){
            $ref = explode(";", $file[$key]);
            for($key_comp=0;$key_comp<count($file); $key_comp++){
                if($key != $key_comp){
                    $comp = explode(";", $file[$key_comp]);
                    if($key_comp==count($file)-1){
						if($ref[0]>$comp[1]){
							$permiteSave++;
						}
						if($ref[1] < $comp[0]){
							$permiteSave++;
						}
					}else {
						if($ref[0]<$comp[0]
							&& $ref[1]<$comp[0]){
							$permiteSave++;
						}
				        if($ref[0]>$comp[1]
							&& $ref[1] > $comp[0])
							$permiteSave++;
					}

                }
            }
        }
	    return $permiteSave >= (count($file)*(count($file)-1));
    }

    private function configuraTabelaPreco_PropVariavel($response) {
        if(count($this->fileArray)==0){
            $response->setError(new Error("COC21004_ARQ_VAZIO", 500));
        } else {
            if(!strpos($this->fileArray[0], ";")){
                $response->setError(new Error("COC21004_SEP_INV", 500));
            } else {
                if (count((explode(";",$this->fileArray[0]))) != 3) {
                    $response->setError(new Error("COC21004_QT_COL_INV", 500));
                } else {
                    $this->removeRegistroTabelaPreco(self::TABELA_PRECO_NM_PROP);
                    for( $i=0; $i < count($this->fileArray); $i++) {
                        try{
                            $lineArray = explode(";",$this->fileArray[$i]);
                            $this->de = $lineArray[0];
                            $this->ate = $lineArray[1];
                            $this->valor = str_replace(',', '.', $lineArray[2]);
                            $this->confereValoresTabelaPreco(self::TABELA_PRECO_NM_PROP);
                            $this->insereRegistroTabelaPreco(self::TABELA_PRECO_NM_PROP);
                        } catch(\Exception $e){
                            $response->setError(new Error("COC21004_ARQ_INV", 500));
                        }
                    }
                }
            }
        }

    }

    private function configuraGrupoManual() {
        $this->removeRegistroGrupoManual();
        for($i=0; $i < count($this->fileArray); $i++) {
            $lineArray = explode(";", $this->fileArray[$i]);
            $this->de = $lineArray[0];
            $this->ate = $lineArray[1];
            $this->valor = str_replace(',', '.', $lineArray[2]);
            $this->confereValoresGrupoManual();
            $this->insereRegistroGrupoManual();
        }
    }

    private function configuraConfServico() {
        $this->removeRegistroConfServico();
        for( $i=0; $i < count($this->fileArray); $i++) {
            $lineArray = explode(";", $this->fileArray[$i]);
            $this->de = $lineArray[0];
            $this->ate = $lineArray[1];
            $this->valor = str_replace(',', '.', $lineArray[2]);
            $this->confereValoresConfServico();
            $this->insereRegistroConfServico();
        }
    }

    private function getArrayFromCSV($csv){
        $fileStr = explode(",", $csv)[1];
        $fileStr = base64_decode($fileStr);
        $fileArray = str_getcsv($fileStr, "\n");
        array_shift($fileArray);
        return $fileArray;
    }

    private function initRows($rows) {

        $this->id = $rows[1]['ID'];
        $this->data = $rows[2]['DATA'];
        $this->file = $rows[0];
        $this->fileArray = $this->getArrayFromCSV($this->file['b64File']);
        $this->cdfilial = $this->data['CDFILIAL'];
        $this->cdcia = isset($this->data['CDCIA']) ? $this->data['CDCIA'] : null;
        $this->nrtabpreco = isset($this->data['NRTABPRECO']) ? $this->data['NRTABPRECO'] : null;
        $this->nrservicociafili = isset($this->data['NRSERVICOCIAFILI']) ? $this->data['NRSERVICOCIAFILI'] : null;
        $this->cdclasse = isset($this->data['CDCLASSE']) ? $this->data['CDCLASSE'] : null;
        $this->cdciclo = isset($this->data['CDCICLO']) ? $this->data['CDCICLO'] : null;
        $this->nrseqpreco = isset($this->data['NRSEQPRECO']) ? $this->data['NRSEQPRECO'] : null;
        $this->cdmancia = isset($this->data['CDMANCIA']) ? $this->data['CDMANCIA'] : null;
        $this->cdsubgru = isset($this->data['CDSUBGRU']) ? $this->data['CDSUBGRU'] : null;
        $this->nrseqsubgrusemam = isset($this->data['NRSEQSUBGRUSEMAM']) ? $this->data['NRSEQSUBGRUSEMAM'] : null;
        $this->nrvoo = isset($this->data['NRVOO']) ? $this->data['NRVOO'] : null;
        $this->cdtrecho = isset($this->data['CDTRECHO']) ? $this->data['CDTRECHO'] : null;
        $this->cdoperador = $this->environment->getCdOperador();
        $this->nrorg = $this->environment->getNrOrg();
        $this->sysdate = $this->environment->getCurrentTime()->format("d/m/Y H:i:s");

    }

    public function uploadCsvFile2(DTO\Request $request, DTO\Response $response){

        try {

            $rows = $request->getDataSet()->getRows();

            $this->initRows($rows);

            if($this->id == self::TABELA_PRECO)
                $this->configuraTabelaPreco($response);

            if($this->id == self::GRUPO_MANUAL)
                $this->configuraGrupoManual();

            if($this->id == self::CONFIGURA_SERVICO)
                $this->configuraConfServico();

            if($this->id == self::TABELA_PRECO_PROP_V)
                $this->configuraTabelaPreco_PropVariavel($response);

        } catch (\Exception $e) {
			$response->setError(new Error($e->getMessage(), 500));
        }

    }
}