<?php

namespace Teknisa\COC\Controllers;

use \Zeedhi\Framework\DTO;
use \Zeedhi\Framework\DTO\Response\Error;
use \Zeedhi\Framework\DataSource\DataSet;
use \Zeedhi\Framework\DataSource\FilterCriteria;
use \Zeedhi\Framework\DataSource\Manager;
use \Zeedhi\Framework\DataSource\ParameterBag;
use \Teknisa\GER\Services\CrudService;
use \Teknisa\GER\Utilities\Messages;
use Teknisa\COC\Controllers;

class ReceitasManual extends \Teknisa\GER\Controllers\TeknisaCrud{ 

    protected $dataSourceManager;
    protected $parameterBag;
    protected $dataSourceName;
    protected $parameterBagColumns = array();

    public function __construct(CrudService $crudService, ParameterBag $parameterBag, $dataSourceManager){
        $this->dataSourceManager = $dataSourceManager;
        parent::__construct($crudService, $parameterBag);
    }

	public function findReceitasDoManual(DTO\Request\Filter $request, DTO\Response $response) {
        if(sizeof($request->getFilterCriteria()->getConditions()) == 3) {
            //significa que não tem nenhum manual selecionado, logo, coloca todos os registros como "pai"
            $this->dataSourceName = "manualciam";
            $filterCriteria = $request->getFilterCriteria();
            $filterCriteria->setDataSourceName($this->dataSourceName);
            $newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $this->parameterBagColumns);
            $dataSet = $this->dataSourceManager->findBy($newFilterCriteria);
            $registros = $dataSet->getRows();

            foreach ($registros as &$row) {
                $row["PRIMARY"] = $row["CDMANCIA"];
                $row["PARENT"] = '';
                $row["DSRECEITA"] = "Manual: ".$row["DSMANUAL"];
                $row["_hasChild"] = true;
            }
            
            $newDataSet = new DataSet($this->dataSourceName, $registros);
        } else if (sizeof($request->getFilterCriteria()->getConditions()) == 1) {
            //filial e companhia não foram filtradas
            $newDataSet = new DataSet($this->dataSourceName, []);
        } else if (sizeof($request->getFilterCriteria()->getConditions()) == 4) {
            //registros filhos do manual
            $this->dataSourceName = "receitam_report";
            $filterCriteria = $request->getFilterCriteria();
            $secFilterCriteria = new FilterCriteria($this->dataSourceName);
            $secFilterCriteria->addCondition("NRORG", "=", $filterCriteria->getConditions()[0]["value"]);
            $secFilterCriteria->addCondition("CDFILIAL", "=", $filterCriteria->getConditions()[1]["value"]);
            $secFilterCriteria->addCondition("CDCIA", "=", $filterCriteria->getConditions()[2]["value"]);
            $secFilterCriteria->addCondition("CDMANCIA", "=", $filterCriteria->getConditions()[3]["value"]);
            $newFilterCriteria = $this->crudService->populateParameterBag($secFilterCriteria, $this->parameterBagColumns);
            $dataSet = $this->dataSourceManager->findBy($newFilterCriteria);
            $registros = $dataSet->getRows();

            foreach ($registros as &$row) {
                $row["PRIMARY"] = $row["CDRECEITA"];
                $row["PARENT"] = $row["CDMANCIA"];
                $row["_hasChild"] = false;
            }
            
            $newDataSet = new DataSet($this->dataSourceName, $registros);
        }

        $response->addDataSet($newDataSet);
	}

}