<?php
namespace Teknisa\COC\Controllers;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO;

class RelatorioProduto extends \Zeedhi\Framework\Controller\Report {
    
    protected $birtStrategy;

    public function __construct(ReportService $reportService, $birtStrategy) {
        parent::__construct($reportService);
        $this->birtStrategy = $birtStrategy;
    }
    
    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        $reportType = $row['REPORTTYPE'];
        $this->birtStrategy->setReportFormat($reportType);
    }
    
    protected $reportMapping = array (
        'COC000A5' => array (
            'strategy'         => 'BIRT',
            'parameterMapping' => array (
                "NRORG"      => "NRORG",
                "CDLEANCODE" => "CDLEANCODE",
                "CDPRODUTO"  => "CDPRODUTO",
                "REPORTTYPE" => "REPORTTYPE",
            )
        ),
        'COC000B5' => array (
            'strategy'         => 'BIRT',
            'parameterMapping' => array (
                "NRORG"        => "NRORG",
                "CDLEANCODE"   => "CDLEANCODE",
                "CDPRODUTO"    => "CDPRODUTO",
                "DSPRODATIVPR" => "IDPRODATIVPR",
                "REPORTTYPE"   => "REPORTTYPE",
            )
        ),
        'COC000C5' => array (
            'strategy'         => 'BIRT',
            'parameterMapping' => array (
                "NRORG"        => "NRORG",
                "CDFILIAL"     => "CDFILIAL",
                "CDLEANCODE"   => "CDLEANCODE",
                "CDPRODUTO"    => "CDPRODUTO",
                "CDCONTROLE"   => "CDCONTROLE",
                "REPORTTYPE"   => "REPORTTYPE",
                "CDCIA"        => "CDCIA"
            )
        )
    );
}