<?php

namespace Teknisa\COC\Controllers;

use Zeedhi\Framework\DTO;
use \Zeedhi\Framework\DTO\Response;
use \Zeedhi\Framework\DTO\Response\Error;
use \Zeedhi\Framework\DataSource\DataSet;

class ServicoCompanhia {

    protected $dataSourceName;
    protected $parameterBagColumns;
    protected $connection;

    const ITEMMENUGRID    = "ITEMMENUGRID";
    const ITEMFATURAMENTO = "ITEMFATURAMENTO";
    const AMBOS           = "AMBOS";
    const INATIVO         = '2';

    const SELECT_TABPRECO_PRECOSECIAM = "SELECT SCF.DSSERVICOCIAFILI, SVG.DSSERVICOGEN, TBP.NMTABPRECO, TBP.DTINIVIGTAB, TBP.DTFIMVIGTAB, SVG.IDSERVICO, SCF.IDTPPRECO, SCF.IDTIPMANUAL, PCS.CDFILIAL, FL.NMFILIAL, PCS.CDCIA, CIA.NMCIA, PCS.NRTABPRECO, PCS.QTPROPORCAO, PCS.IDPROPORCAO, PCS.NRSERVICOCIAFILI, PCS.CDCLASSE, PCS.CDCICLO, PCS.NRSEQPRECO, PCS.DTINIVIGSE, PCS.DTFIMVIGSE, PCS.VRPRESERV, PCS.VRPRESERVD, PCS.NRORG, PCS.CDMANCIA, SCF.NRSERVICOCIAFILI FROM PRECOSECIAM PCS INNER JOIN TABPRECOSEM TBP ON TBP.CDFILIAL = PCS.CDFILIAL AND TBP.CDCIA = PCS.CDCIA AND TBP.NRTABPRECO = PCS.NRTABPRECO AND TBP.NRORG = PCS.NRORG INNER JOIN SERVICOCIAFILI SCF ON SCF.CDFILIAL = PCS.CDFILIAL AND SCF.CDCIA = PCS.CDCIA AND SCF.NRSERVICOCIAFILI = PCS.NRSERVICOCIAFILI INNER JOIN SERVICOGEN SVG ON SVG.NRSERVICOGEN = SCF.NRSERVICOGEN INNER JOIN COMPANHIA CIA ON CIA.CDCIA = PCS.CDCIA AND CIA.NRORG = PCS.NRORG INNER JOIN FILIAL FL ON FL.CDFILIAL = PCS.CDFILIAL AND FL.NRORG = PCS.NRORG WHERE PCS.CDFILIAL = :CDFILIAL AND PCS.CDCIA = :CDCIA AND PCS.NRSERVICOCIAFILI = :NRSERVICOCIAFILI AND PCS.NRORG = :NRORG";
    const SELECT_PRECOSESUBGRU_MANUALCIAM = "SELECT PSG.NRSERVICOCIAFILI, PSG.NRSEQSUBGRUSEMAM, PSG.CDMANCIA, MN.DSMANUAL, SG.DSSUBGRU, SCF.DSSERVICOCIAFILI, SVG.DSSERVICOGEN, PSG.CDFILIAL, FL.NMFILIAL, PSG.CDCIA, CIA.NMCIA FROM PRECOSESUBGRU PSG INNER JOIN MANUALCIAM MN ON MN.CDFILIAL = PSG.CDFILIAL AND MN.CDCIA = PSG.CDCIA AND MN.CDMANCIA = PSG.CDMANCIA AND MN.NRORG = PSG.NRORG INNER JOIN SUBGRUSEMAM SGS ON SGS.CDFILIAL = PSG.CDFILIAL AND SGS.CDCIA = PSG.CDCIA AND SGS.CDMANCIA = PSG.CDMANCIA AND SGS.NRSERVICOCIAFILI = PSG.NRSERVICOCIAFILI AND SGS.NRSEQSUBGRUSEMAM = PSG.NRSEQSUBGRUSEMAM INNER JOIN SUBGRUPOM SG ON SG.CDSUBGRU = SGS.CDSUBGRU INNER JOIN SERVICOCIAFILI SCF ON SCF.CDFILIAL = PSG.CDFILIAL AND SCF.CDCIA = PSG.CDCIA AND SCF.NRSERVICOCIAFILI = PSG.NRSERVICOCIAFILI AND SCF.NRORG = PSG.NRORG INNER JOIN SERVICOGEN SVG ON SVG.NRSERVICOGEN = SCF.NRSERVICOGEN INNER JOIN COMPANHIA CIA ON CIA.CDCIA = PSG.CDCIA AND CIA.NRORG = PSG.NRORG INNER JOIN FILIAL FL ON FL.CDFILIAL = PSG.CDFILIAL AND FL.NRORG = PSG.NRORG WHERE PSG.CDFILIAL = :CDFILIAL AND PSG.CDCIA = :CDCIA AND PSG.NRSERVICOCIAFILI = :NRSERVICOCIAFILI AND PSG.NRORG = :NRORG";
    const SELECT_SERVMANUALM_MANUALCIAM = "SELECT SG.DSSERVICOGEN, SG.NRSERVICOGEN, SCF.NRSERVICOCIAFILI, MN.DSMANUAL, MN.CDMANCIA, SM.CDCIA, SM.CDFILIAL, CIA.NMCIA, FL.NMFILIAL FROM SERVMANUALM SM JOIN SERVICOCIAFILI SCF ON SCF.CDFILIAL = SM.CDFILIAL AND SCF.CDCIA = SM.CDCIA AND SCF.NRSERVICOCIAFILI = SM.NRSERVICOCIAFILI AND SCF.NRORG = SM.NRORG JOIN SERVICOGEN SG ON SG.NRSERVICOGEN = SCF.NRSERVICOGEN AND SG.NRORG = SCF.NRORG JOIN MANUALCIAM MN ON MN.CDFILIAL = SM.CDFILIAL AND MN.CDCIA = SM.CDCIA AND MN.CDMANCIA = SM.CDMANCIA AND MN.NRORG = SM.NRORG INNER JOIN COMPANHIA CIA ON CIA.CDCIA = SM.CDCIA AND CIA.NRORG = SM.NRORG INNER JOIN FILIAL FL ON FL.CDFILIAL = SM.CDFILIAL AND FL.NRORG = SM.NRORG WHERE SM.CDFILIAL = :CDFILIAL AND SM.CDCIA = :CDCIA AND SM.NRSERVICOCIAFILI = :NRSERVICOCIAFILI AND SM.NRORG = :NRORG";
    const SELECT_SERVICOCIAFILI = "SELECT IDSITSERVICO, IDTIPOSERVICO FROM SERVICOCIAFILI WHERE NRSERVICOCIAFILI = :NRSERVICOCIAFILI AND CDCIA = :CDCIA AND CDFILIAL = :CDFILIAL AND NRORG = :NRORG";

    public function __construct($environment, $connection) {
        $this->environment=$environment;
        $this->connection = $connection;
    }

    public function validateChangedStatus(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        $conditions = array(
                "CDFILIAL" =>         $row['CDFILIAL'],
                "CDCIA" =>            $row['CDCIA'],
                "NRSERVICOCIAFILI" => $row['NRSERVICOCIAFILI'],
                "NRORG" =>            $this->environment->getNrOrg()
        );
        $tipoItem = $row['IDTIPOSERVICO'];
        $messages = array();
        $oldService = $this->searchOldService($conditions);
        
        if($oldService[0]['IDSITSERVICO'] == self::INATIVO && $row['IDSITSERVICO'] == self::INATIVO){
            $messages = array();
        } else if($oldService[0]['IDSITSERVICO'] != self::INATIVO && $row['IDSITSERVICO'] == self::INATIVO){
            $messages = $this->checkInative($tipoItem, $conditions, $oldService);
        } else if ($oldService[0]['IDTIPOSERVICO'] != $row['IDTIPOSERVICO']) {
            $messages = $this->checkAlterItem($tipoItem, $conditions, $oldService);
        }
        $response->addDataSet(new DataSet("MENSSAGESERROR", $messages));
    }

    private function searchOldService($conditions) {
        $dataSetServices = $this->executeQuery($conditions, self::SELECT_SERVICOCIAFILI);
        return $dataSetServices;
    }

    private function checkInative($tipoItem, $conditions, $oldService){
        $messages = array();
        if($oldService[0]['IDTIPOSERVICO'] == self::AMBOS){
            $messages = $this->checkInativaItemFaturamento($conditions);
            $messagesMenuGrid = $this->checkInativaMenuGrid($conditions);
            if(!empty($messages))
                array_merge($messages, $messagesMenuGrid);
            else $messages = $messagesMenuGrid;
        } else if($oldService[0]['IDTIPOSERVICO'] == self::ITEMFATURAMENTO){
            $messages = $this->checkInativaItemFaturamento($conditions);
        } else if($oldService[0]['IDTIPOSERVICO'] == self::ITEMMENUGRID){
            $messages = $this->checkInativaMenuGrid($conditions);
        }
        return $messages;
    }

    private function checkAlterItem($tipoItem, $conditions, $oldService){
        $messages = array();
        if($oldService[0]['IDTIPOSERVICO'] == self::ITEMFATURAMENTO && $tipoItem == self::ITEMMENUGRID){
            $messages = $this->checkVinculoItemFaturamento($conditions);            
        } else if($oldService[0]['IDTIPOSERVICO'] == self::ITEMMENUGRID && $tipoItem == self::ITEMFATURAMENTO){
            $messages = $this->checkVinculoMenuGrid($conditions);
        } else if($oldService[0]['IDTIPOSERVICO'] == self::AMBOS){
            if($tipoItem == self::ITEMMENUGRID)
                $messages = $this->checkVinculoItemFaturamento($conditions);
            else if($tipoItem == self::ITEMFATURAMENTO)
                $messages = $this->checkVinculoMenuGrid($conditions);
            else
                $messages = array();
        }
        return $messages;
    }

    private function checkInativaItemFaturamento($conditions){
        $messages = array();
        $flag = true;
        $dataSetTab = $this->executeQuery($conditions, self::SELECT_TABPRECO_PRECOSECIAM);
        if(!empty($dataSetTab)){
            array_push($messages, '                                             Operação bloqueada. Impossível inativar Serviço!');
            $messages = $this->concatArrayMessage($dataSetTab, 'MSG_TABPRECO_PRECOSECIAM', $messages);
            $flag = false;
        }
        
        $dataVinculo = $this->executeQuery($conditions, self::SELECT_PRECOSESUBGRU_MANUALCIAM);
        if(!empty($dataVinculo)){
            if($flag)
                array_push($messages, '                                             Operação bloqueada. Impossível inativar Serviço!');
            $messages = $this->concatArrayMessage($dataVinculo, 'MSG_PRECOSESUBGRU_MANUALCIAM', $messages);
        }
        return $messages;
    }

    private function checkInativaMenuGrid($conditions){
        $messages = array();
        $dataSetManual = $this->executeQuery($conditions, self::SELECT_SERVMANUALM_MANUALCIAM);
        if(!empty($dataSetManual)){
            array_push($messages, '                                             Operação bloqueada. Impossível inativar Serviço!');
            $messages = $this->concatArrayMessage($dataSetManual, 'MSG_SERVMANUALM_MANUALCIAM', $messages);
        }
        return $messages;
    }

    private function checkVinculoItemFaturamento($conditions){
        $messages = array();
        $flag = true;
        $dataSetTab = $this->executeQuery($conditions, self::SELECT_TABPRECO_PRECOSECIAM);
        if(!empty($dataSetTab)){
            array_push($messages, '                                             Impossível alterar Tipo de Item do Serviço!');
            $messages = $this->concatArrayMessage($dataSetTab, 'MSG_TABPRECO_PRECOSECIAM', $messages);
            $flag = false;
        }
        
        $dataVinculo = $this->executeQuery($conditions, self::SELECT_PRECOSESUBGRU_MANUALCIAM);
        if(!empty($dataVinculo)){
            if($flag)
                array_push($messages, '                                             Impossível alterar Tipo de Item do Serviço!');
            $messages = $this->concatArrayMessage($dataVinculo, 'MSG_PRECOSESUBGRU_MANUALCIAM', $messages);
        }
        return $messages;
    }

    private function checkVinculoMenuGrid($conditions){
        $messages = array();
        $dataSetManual = $this->executeQuery($conditions, self::SELECT_SERVMANUALM_MANUALCIAM);
        if(!empty($dataSetManual)){
            array_push($messages, '                                             Impossível alterar Tipo de Item do Serviço!');
            $messages = $this->concatArrayMessage($dataSetManual, 'MSG_SERVMANUALM_MANUALCIAM', $messages);
        }
        return $messages;
    }

    private function concatArrayMessage($dataSet, $position, $messages){
        foreach ($dataSet as $servico) {
            array_push($messages, $this->getMessage($position, $servico));
        }
        return $messages;
    }
    private function getMessage($code, $param) {
        $msg = "";
        if($code == 'MSG_TABPRECO_PRECOSECIAM'){
            $msg = "Item '" . $param['DSSERVICOGEN'] . "' é um item de faturamento vinculado à Tabela de Preços '".$param['NMTABPRECO']." Vigência ".substr($param['DTINIVIGTAB'], 0, 10)." - ".substr($param['DTFIMVIGTAB'], 0, 10)."' da Companhia '" .$param['NMCIA']."' e Unidade '" .$param['NMFILIAL']."'.";
        } else if($code == 'MSG_PRECOSESUBGRU_MANUALCIAM'){
            $msg = "Item '" . $param['DSSERVICOGEN'] . "' é um item de faturamento vinculado com Subgrupo '" . $param['DSSUBGRU'] . "' pertencente ao Menu Grid '" . $param['DSMANUAL'] ."' da Companhia '" .$param['NMCIA']."' e Unidade '" .$param['NMFILIAL']."'.";
        } else if($code == 'MSG_SERVMANUALM_MANUALCIAM'){
            $msg = "Item '".$param['DSSERVICOGEN']."' é um item do Menu Grid '".$param['DSMANUAL']. "' da Companhia '" .$param['NMCIA']."' e Unidade '" .$param['NMFILIAL']."'.";
        }
        return $msg;
    }
    private function executeQuery($conditions, $query){
        $stmt = $this->connection->prepare($query);
        $stmt->execute($conditions);
        return $stmt->fetchAll(\PDO::FETCH_ASSOC);
    }

}