<?php

namespace Teknisa\COC\Services;

use Zeedhi\Framework\DTO\Response\Error;
use \Doctrine\ORM\EntityManager;

class ExportacaoSAPService {
	protected $connection;
	protected $entityManager;

	public function __construct(EntityManager $entityManager) {
		$this->connection = $entityManager->getConnection();
		$this->entityManager = $entityManager;
	}

	public function insertLista($nrlista, $row, $tvootrecho) {
		$sql;
		$params;
		if ($tvootrecho) {
			$sql = "INSERT INTO LISTA(NRLISTA, CDLISTA) SELECT :novoCodVooTrecho, NRVOO||CDTRECHO FROM VOOTRECHO WHERE CDFILIAL = :P_CDFILIAL AND CDCIA = :P_CDCIA AND NRORG = :P_NRORG";
			$params = array(
				"novoCodVooTrecho" => $nrlista,
				"P_CDFILIAL" => $row['CDFILIAL'],
				"P_CDCIA" => $row['CDCIA'],
				"P_NRORG" => $row['NRORG']
			);
		} else {
			$sql = "INSERT INTO LISTA(NRLISTA, CDLISTA) VALUES (:novoCodVooTrecho, :P_NRVOO||:P_CDTRECHO)";
			$params = array(
				"novoCodVooTrecho" => $nrlista,
				"P_NRVOO" => $row['NRVOO'],
				"P_CDTRECHO" => $row['CDTRECHO']
			);
		}
		
		$query = $this->connection->prepare($sql);
		$query->execute($params);
	}

	public function updateDelivery($cdfilial, $cdcia, $dtini, $dtfin, $nrlista, $nrorg) {
		$params = array(
			"P_CDFILIAL" => $cdfilial,
			"P_CDCIA" => $cdcia,
			"P_DTINI" => $dtini,
			"P_DTFIN" => $dtfin,
			"P_NRLISTA" => $nrlista,
			"P_NRORG" => $nrorg
		);
		$sql = "UPDATE DELIVERYM SET IDDELIEXPSAP = 'S' WHERE CDFILIAL = :P_CDFILIAL AND CDCIA = :P_CDCIA AND DTEMISDEL BETWEEN :P_DTINI AND :P_DTFIN AND EXISTS(SELECT 1 FROM LISTA WHERE NRLISTA = :P_NRLISTA AND CDLISTA = DELIVERYM.NRVOO||DELIVERYM.CDTRECHO) AND IDSITDEL <> '3' AND NRORG = :P_NRORG";
		$query = $this->connection->prepare($sql);
		$query->execute($params);
	}

	public function findArquivo($cdfilial, $cdcia, $dtini, $dtfin, $nrlista, $nrorg, $id, $exportName) {
		$exportIDDELIEXPSAP = '';
		if($exportName == '03'){
			$exportIDDELIEXPSAP = 'S';
		}else{
			$exportIDDELIEXPSAP = 'N';
		}
		$params = array(
			"P_CDFILIAL" => $cdfilial,
			"P_DTINI" => $dtini,
			"P_CDCIA" => $cdcia,
			"P_NRLISTA" => $nrlista,
			"P_DTFIN" => $dtfin,
			"P_NRORG" => $nrorg
		);
		
		if ($id == '0')
			$rows = $this->connection->fetchAll("SELECT 'H' || :P_CDFILIAL || '20' || '20' || LPAD(DE.NRDELIVERY,35,0) || RPAD(CO.SGCIA,5,' ') || RPAD(DE.NRVOO,5,' ') || TO_CHAR(DE.DTHRPLAVOOPV, 'DDMMYYYY') || RPAD(:P_CDCIA, 10,' ') || RPAD(:P_CDCIA, 10,' ') || NVL(TO_CHAR(DE.DTEMISDEL, 'DDMMYYYY'),'00000000') || LPAD(TRUNC(NVL(DE.VRPETXAERO,0)),3,0) || LPAD((ROUND((NVL(DE.VRPETXAERO,0) - TRUNC(NVL(DE.VRPETXAERO,0))),2))*100,2,0) || LPAD(TRUNC(DECODE(DE.IDTIPNACDEL,1,NVL(DE.VRTXAEROR,0),NVL(DE.VRTXAEROD,0))),11,0) || LPAD((ROUND((DECODE(DE.IDTIPNACDEL,1,NVL(DE.VRTXAEROR,0),NVL(DE.VRTXAEROD,0)) - TRUNC(DECODE(DE.IDTIPNACDEL,1,NVL(DE.VRTXAEROR,0),NVL(DE.VRTXAEROD,0)))),2))*100,2,0) || LPAD(COUNT(SE.NRITEMPLANSP),5,'0') || RPAD(EQ.SGEQUIP,15,' ') || RPAD(BO.SGBASE || '-' || BD.SGBASE, 7, ' ') || MAX(SUBSTR(INDICADOR_TIPO_VOO_DELIVERY(DE.CDFILIAL, DE.CDCIA, DE.NRVOO, DE.CDTRECHO, PV.SGPREFIXO, PV.CDEQUIP, DE.NRDELIVERY, DE.DTHRPLAVOOPV, DE.NRORG), 1, 1 )) || LPAD(NVL(DE.CDPURCHASEORDER, '0'), 12, '0') AS CAMPOUNICO, DE.CDFILIAL, DE.NRDELIVERY, 0 AS ORDEM, 0 AS P_DTINI, 0 AS P_CDCIA, 0 AS P_NRLISTA, 0 AS P_DTFIN, 0 AS P_CDFILIAL FROM DELIVERYM DE INNER JOIN PLANOVOOM PV ON PV.CDFILIAL = DE.CDFILIAL AND PV.CDCIA = DE.CDCIA AND PV.NRVOO = DE.NRVOO AND PV.CDTRECHO = DE.CDTRECHO AND PV.DTHRPLAVOOPV = DE.DTHRPLAVOOPV INNER JOIN SERVPLANOM SE ON SE.CDFILIAL = DE.CDFILIAL AND SE.NRDELIVERY = DE.NRDELIVERY INNER JOIN COMPANHIA CO ON CO.CDCIA = DE.CDCIA INNER JOIN EQUIPAMENTO EQ ON EQ.CDEQUIP = PV.CDEQUIP INNER JOIN VOOTRECHO VT ON VT.CDFILIAL = DE.CDFILIAL AND VT.CDCIA = DE.CDCIA AND VT.NRVOO = DE.NRVOO AND VT.CDTRECHO = DE.CDTRECHO INNER JOIN BASE BO ON BO.CDBASE = VT.CDBASEORI INNER JOIN BASE BD ON BD.CDBASE = VT.CDBASEDES INNER JOIN VOO VO ON VO.CDFILIAL = DE.CDFILIAL AND VO.CDCIA = DE.CDCIA AND VO.NRVOO = DE.NRVOO INNER JOIN LISTA L ON L.NRLISTA = :P_NRLISTA AND DE.NRVOO ||DE.CDTRECHO = L.CDLISTA WHERE(DE.CDFILIAL = :P_CDFILIAL) AND(DE.CDCIA = :P_CDCIA) AND(DE.DTEMISDEL BETWEEN :P_DTINI AND :P_DTFIN) AND (DE.IDDELIEXPSAP = '$exportIDDELIEXPSAP') AND (DE.IDSITDEL <> '3') GROUP BY DE.NRDELIVERY, DE.DTHRPLAVOOPV, TO_CHAR(DE.DTEMISDEL, 'DDMMYYYY'), DE.VRPETXAERO, DE.VRTXAEROR, DE.VRTXAEROD, DE.IDTIPNACDEL, DE.CDFILIAL, CO.SGCIA, DE.NRVOO, EQ.SGEQUIP, BO.SGBASE, BD.SGBASE, DE.CDPURCHASEORDER UNION ALL SELECT 'I' || LPAD(SE.NRDELIVERY,35,0) || LPAD(SE.NRITEMPLANSP,5,0) || RPAD(SUBSTR(SCL.CDINTEGRASAP,1, 18),18,' ') || LPAD(TRUNC(NVL(SE.QTSERFATSP,0)),15,0) || LPAD(ROUND(NVL(SE.QTSERFATSP, 0) - TRUNC(NVL(SE.QTSERFATSP, 0)),3)*1000,3,0) || RPAD(SG.SGUNIDADE,2,' ') || LPAD(TRUNC(DECODE(SE.IDTIPMANUALSP,1,NVL(SE.VRPRURESESP,0), NVL(SE.VRPRUDOLSESP, 0))),11,0) || LPAD(ROUND(DECODE(SE.IDTIPMANUALSP,1,NVL(SE.VRPRURESESP,0) -TRUNC(NVL(SE.VRPRURESESP,0)),NVL(SE.VRPRUDOLSESP,0) - TRUNC(NVL(SE.VRPRUDOLSESP,0))),4)*10000,4,0) || DECODE(SE.IDTIPMANUALSP,1,LPAD(TRUNC(NVL(SE.VRDESCRESESP,0) + NVL(SE.VRDESCONDRSP,0) + NVL(SE.VRDESFIXORSP,0)),9,0) || LPAD(ROUND(NVL(SE.VRDESCRESESP,0) + NVL(SE.VRDESCONDRSP,0) + NVL(SE.VRDESFIXORSP,0) - TRUNC(NVL(SE.VRDESCRESESP,0) + NVL(SE.VRDESCONDRSP,0) + NVL(SE.VRDESFIXORSP,0)),4)*10000,4,0), LPAD(TRUNC(NVL(SE.VRDESCDOSESP,0) + NVL(SE.VRDESCONDDSP,0) + NVL(SE.VRDESFIXODSP,0)),9,0) || LPAD(ROUND(NVL(SE.VRDESCDOSESP,0) + NVL(SE.VRDESCONDDSP,0) + NVL(SE.VRDESFIXODSP,0) - TRUNC(NVL(VRDESCDOSESP,0) + NVL(SE.VRDESCONDDSP,0) + NVL(SE.VRDESFIXODSP, 0)),4)*10000,4,0)) || RPAD(ID.SGINDICE,3,' ') || :P_CDFILIAL || LPAD(TRUNC(NVL(SE.QTATUAPRODSP,0)),15,0) || LPAD(ROUND(NVL(SE.QTREALPROD,0)-TRUNC(NVL(SE.QTREALPROD,0)),3)*1000,3,0) || LPAD(NVL(SE.QTSESBYUTSP,0),2,0) || LPAD(TRUNC(DECODE(NVL(SE.VRDESCPROP,0), 0, NVL(SE.VRPRUSBYSP *(CF.VRPERSBYUT/100)*SE.QTSESBYUTSP,0), NVL(SE.VRPRUSBYSP*SE.QTSESBYUTSP, 0))),9,0) || LPAD(ROUND(DECODE(NVL(SE.VRDESCPROP,0), 0, NVL(SE.VRPRUSBYSP *(CF.VRPERSBYUT/100)*SE.QTSESBYUTSP,0), NVL(SE.VRPRUSBYSP*SE.QTSESBYUTSP,0))-TRUNC(DECODE(NVL(SE.VRDESCPROP,0), 0, NVL(SE.VRPRUSBYSP*(CF.VRPERSBYUT/100)*SE.QTSESBYUTSP,0), NVL(SE.VRPRUSBYSP*SE.QTSESBYUTSP, 0))),4)*10000,4,0) || LPAD(NVL(SE.QTSESBYPRSP -SE.QTSESBYUTSP, 0),2,0) || LPAD(TRUNC(DECODE(NVL(SE.VRNUSADO,0), 0, NVL(SE.VRPRUSBYSP *(CF.VRPERSBYNUT/100)*(SE.QTSESBYPRSP-SE.QTSESBYUTSP),0), NVL(SE.VRNUSADO,0))),9,0) ||LPAD(ROUND(DECODE(NVL(SE.VRNUSADO,0), 0, NVL(SE.VRPRUSBYSP *(CF.VRPERSBYNUT/100)*(SE.QTSESBYPRSP-SE.QTSESBYUTSP),0), NVL(SE.VRNUSADO,0))-TRUNC(DECODE(NVL(SE.VRNUSADO,0), 0, NVL(SE.VRPRUSBYSP*(CF.VRPERSBYNUT/100)*(SE.QTSESBYPRSP-SE.QTSESBYUTSP),0), NVL(SE.VRNUSADO,0))),4)*10000,4,0) || DECODE(SE.IDTPPRECOSP,'1',' ','X') || DECODE(SE.IDTIPMANUALSP,1,DECODE(INSTR(VRDESDESVRSP,'-'),0,LPAD(TRUNC(VRDESDESVRSP),9,0) || LPAD(ROUND(VRDESDESVRSP-TRUNC(VRDESDESVRSP),4)*10000,4,0),'-' || LPAD(ABS(TRUNC(VRDESDESVRSP)),8,0) || LPAD(ABS(ROUND(VRDESDESVRSP-TRUNC(VRDESDESVRSP),4))*10000,4,0)), DECODE(INSTR(VRDESDESVDSP,'-'),0,LPAD(TRUNC(VRDESDESVDSP),9,0) || LPAD(ROUND(VRDESDESVDSP -TRUNC(VRDESDESVDSP),4)*10000,4,0),'-' || LPAD(ABS(TRUNC(VRDESDESVDSP)),8,0) || LPAD(ABS(ROUND(VRDESDESVDSP-TRUNC(VRDESDESVDSP),4))*10000,4,0))) || LPAD(NVL(SE.CDSEQPURCHASEORDER, '0'), 6, '0') || LPAD(NVL(DE.CDPURCHASEORDER, '0'), 12, '0') AS CAMPOUNICO, DE.CDFILIAL, DE.NRDELIVERY, 1 AS ORDEM, 0 AS P_DTINI, 0 AS P_CDCIA, 0 AS P_NRLISTA, 0 AS P_DTFIN, 0 AS P_CDFILIAL FROM SERVPLANOM SE INNER JOIN DELIVERYM DE ON DE.CDFILIAL = SE.CDFILIAL AND DE.NRDELIVERY = SE.NRDELIVERY INNER JOIN LISTA L ON L.NRLISTA = :P_NRLISTA AND DE.NRVOO ||DE.CDTRECHO = L.CDLISTA INNER JOIN SERVCICLO SCL ON SCL.CDFILIAL = SE.CDFILIAL AND SCL.CDCIA = SE.CDCIA AND SCL.NRSERVICOCIAFILI = SE.NRSERVICOCIAFILI AND SCL.CDCICLO = SE.CDCICLO AND SCL.CDCLASSE = SE.CDCLASSE INNER JOIN SERVICOCIAFILI SCF ON SCF.CDFILIAL = SCL.CDFILIAL AND SCF.CDCIA = SCL.CDCIA AND SCF.NRSERVICOCIAFILI = SCL.NRSERVICOCIAFILI INNER JOIN SERVICOGEN SG ON SG.NRSERVICOGEN = SCF.NRSERVICOGEN INNER JOIN CIAFILI CF ON CF.CDFILIAL = SE.CDFILIAL AND CF.CDCIA = SE.CDCIA LEFT JOIN INDICE ID ON ID.CDTPINDICE = CF.CDTPINDICE AND ID.IDPERVALOR = CF.IDPERVALOR AND ID.CDINDICE = CF.CDINDICE WHERE (DE.CDFILIAL = :P_CDFILIAL) AND (DE.NRORG = :P_NRORG) AND (DE.CDCIA = :P_CDCIA ) AND (DE.DTEMISDEL BETWEEN :P_DTINI AND :P_DTFIN) AND (DE.IDDELIEXPSAP = '$exportIDDELIEXPSAP') AND (DE.IDSITDEL <> '3') ORDER BY CDFILIAL, NRDELIVERY, ORDEM", $params);
		else if ($id == '1')
			$rows = $this->connection->fetchAll("SELECT 'H' || DE.CDFILIAL || '20' || '20' || LPAD(TO_CHAR(DE.NRDELIVERY),35,'0') || RPAD(CO.SGCIA,5,' ') || RPAD(DE.NRVOO,5,' ') || TO_CHAR(DE.DTHRPLAVOOPV, 'DDMMYYYY') || RPAD(:P_CDCIA, 10,' ') || RPAD(:P_CDCIA, 10,' ') || NVL(TO_CHAR(DE.DTEMISDEL, 'DDMMYYYY'),'00000000') || LPAD(TRUNC(NVL(DE.VRPETXAERO,0)),3,0) || LPAD((ROUND((NVL(DE.VRPETXAERO,0) - TRUNC(NVL(DE.VRPETXAERO,0))),2))*100,2,0) || LPAD(TRUNC(DECODE(DE.IDTIPNACDEL,1,NVL(DE.VRTXAEROR,0),NVL(DE.VRTXAEROD,0))),11,0) || LPAD((ROUND((DECODE(DE.IDTIPNACDEL,1,NVL(DE.VRTXAEROR,0),NVL(DE.VRTXAEROD,0)) - TRUNC(DECODE(DE.IDTIPNACDEL,1,NVL(DE.VRTXAEROR,0),NVL(DE.VRTXAEROD,0)))),2))*100,2,0) || LPAD(COUNT(SE.NRITEMPLANSP),5,'0') || RPAD(EQ.SGEQUIP,15,' ') || RPAD(BO.SGBASE ||'-' ||BD.SGBASE, 7, ' ') || MAX(SUBSTR(INDICADOR_TIPO_VOO_DELIVERY(DE.CDFILIAL, DE.CDCIA, DE.NRVOO, DE.CDTRECHO, PV.SGPREFIXO, PV.CDEQUIP, DE.NRDELIVERY, DE.DTHRPLAVOOPV, DE.NRORG), 1, 1 )) || LPAD(CO.CDTPCIA, 10, ' ') || LPAD(NVL(DE.CDPURCHASEORDER, '0'), 12, '0') AS CAMPOUNICO, DE.CDFILIAL, DE.NRDELIVERY, 0 AS ORDEM FROM DELIVERYM DE INNER JOIN PLANOVOOM PV ON PV.CDFILIAL = DE.CDFILIAL AND PV.CDCIA = DE.CDCIA AND PV.NRVOO = DE.NRVOO AND PV.CDTRECHO = DE.CDTRECHO AND PV.DTHRPLAVOOPV = DE.DTHRPLAVOOPV INNER JOIN SERVPLANOM SE ON SE.CDFILIAL = DE.CDFILIAL AND SE.NRDELIVERY = DE.NRDELIVERY INNER JOIN COMPANHIA CO ON CO.CDCIA = DE.CDCIA INNER JOIN EQUIPAMENTO EQ ON EQ.CDEQUIP = PV.CDEQUIP INNER JOIN VOOTRECHO VT ON VT.CDFILIAL = DE.CDFILIAL AND VT.CDCIA = DE.CDCIA AND VT.NRVOO = DE.NRVOO AND VT.CDTRECHO = DE.CDTRECHO INNER JOIN BASE BO ON BO.CDBASE = VT.CDBASEORI INNER JOIN BASE BD ON BD.CDBASE = VT.CDBASEDES INNER JOIN VOO VO ON VO.CDFILIAL = DE.CDFILIAL AND VO.CDCIA = DE.CDCIA AND VO.NRVOO = DE.NRVOO INNER JOIN LISTA L ON L.NRLISTA = :P_NRLISTA AND DE.NRVOO || DE.CDTRECHO = L.CDLISTA WHERE(DE.CDFILIAL = :P_CDFILIAL) AND (DE.CDCIA = :P_CDCIA) AND (DE.DTEMISDEL BETWEEN :P_DTINI AND :P_DTFIN) AND (DE.IDDELIEXPSAP = '$exportIDDELIEXPSAP') AND (DE.IDSITDEL <> '3') AND (SE.IDSITSERSP <> '3') AND (DE.CDFILIAL NOT IN ( '0014', '0013')) GROUP BY DE.NRDELIVERY, DE.DTHRPLAVOOPV, TO_CHAR(DE.DTEMISDEL, 'DDMMYYYY'), DE.VRPETXAERO, DE.VRTXAEROR, DE.VRTXAEROD, DE.IDTIPNACDEL, DE.CDFILIAL, CO.SGCIA, DE.NRVOO, EQ.SGEQUIP, BO.SGBASE, BD.SGBASE, CO.CDTPCIA, DE.CDPURCHASEORDER UNION ALL SELECT 'H' || DE.CDFILIAL || '20' || '20' || LPAD(TO_CHAR(NVL(DE.NRDELIVERYFA, '0')),35,'0') || RPAD(CO.SGCIA,5,' ') || RPAD(DE.NRVOO,5,' ') || TO_CHAR(DE.DTHRPLAVOOPV, 'DDMMYYYY') || RPAD(:P_CDCIA, 10,' ') || RPAD(:P_CDCIA, 10,' ') || NVL(TO_CHAR(DE.DTEMISDEL, 'DDMMYYYY'),'00000000') || LPAD(TRUNC(NVL(DE.VRPETXAERO,0)),3,0) || LPAD((ROUND((NVL(DE.VRPETXAERO,0) - TRUNC(NVL(DE.VRPETXAERO,0))),2))*100,2,0) || LPAD(TRUNC(DECODE(DE.IDTIPNACDEL,1,NVL(DE.VRTXAEROR,0),NVL(DE.VRTXAEROD,0))),11,0) || LPAD((ROUND((DECODE(DE.IDTIPNACDEL,1,NVL(DE.VRTXAEROR,0),NVL(DE.VRTXAEROD,0)) - TRUNC(DECODE(DE.IDTIPNACDEL,1,NVL(DE.VRTXAEROR,0),NVL(DE.VRTXAEROD,0)))),2))*100,2,0) || LPAD(COUNT(SE.NRITEMPLANSP),5,'0') || RPAD(EQ.SGEQUIP,15,' ') || RPAD(BO.SGBASE ||'-' || BD.SGBASE, 7, ' ') || MAX(SUBSTR(INDICADOR_TIPO_VOO_DELIVERY(DE.CDFILIAL, DE.CDCIA, DE.NRVOO, DE.CDTRECHO, PV.SGPREFIXO, PV.CDEQUIP, DE.NRDELIVERY, DE.DTHRPLAVOOPV, DE.NRORG), 1, 1 )) || LPAD(CO.CDTPCIA, 10, ' ') || RPAD(' ',10,' ') || TO_CHAR(:P_DTINI, 'DDMMYYYY') || TO_CHAR(:P_DTFIN, 'DDMMYYYY') || LPAD(NVL(DE.CDPURCHASEORDER, '0'), 12, '0') AS CAMPOUNICO, DE.CDFILIAL, DE.NRDELIVERY, 0 AS ORDEM FROM DELIVERYM DE INNER JOIN PLANOVOOM PV ON PV.CDFILIAL = DE.CDFILIAL AND PV.CDCIA = DE.CDCIA AND PV.NRVOO = DE.NRVOO AND PV.CDTRECHO = DE.CDTRECHO AND PV.DTHRPLAVOOPV = DE.DTHRPLAVOOPV INNER JOIN SERVPLANOM SE ON SE.CDFILIAL = DE.CDFILIAL AND SE.NRDELIVERY = DE.NRDELIVERY INNER JOIN COMPANHIA CO ON CO.CDCIA = DE.CDCIA INNER JOIN EQUIPAMENTO EQ ON EQ.CDEQUIP = PV.CDEQUIP INNER JOIN VOOTRECHO VT ON VT.CDFILIAL = DE.CDFILIAL AND VT.CDCIA = DE.CDCIA AND VT.NRVOO = DE.NRVOO AND VT.CDTRECHO = DE.CDTRECHO INNER JOIN BASE BO ON BO.CDBASE = VT.CDBASEORI INNER JOIN BASE BD ON BD.CDBASE = VT.CDBASEDES INNER JOIN VOO VO ON VO.CDFILIAL = DE.CDFILIAL AND VO.CDCIA = DE.CDCIA AND VO.NRVOO = DE.NRVOO INNER JOIN LISTA L ON L.NRLISTA = :P_NRLISTA AND DE.NRVOO ||DE.CDTRECHO = L.CDLISTA WHERE (DE.CDFILIAL = :P_CDFILIAL) AND (DE.CDCIA = :P_CDCIA) AND (DE.DTEMISDEL BETWEEN :P_DTINI AND :P_DTFIN) AND (DE.IDDELIEXPSAP = '$exportIDDELIEXPSAP') AND (DE.IDSITDEL <> '3') AND (SE.IDSITSERSP <> '3') AND (DE.CDFILIAL = '0014') GROUP BY DE.NRDELIVERY, DE.NRDELIVERYFA, DE.DTHRPLAVOOPV, TO_CHAR(DE.DTEMISDEL, 'DDMMYYYY'), DE.VRPETXAERO, DE.VRTXAEROR, DE.VRTXAEROD, DE.IDTIPNACDEL, DE.CDFILIAL, CO.SGCIA, DE.NRVOO, EQ.SGEQUIP, BO.SGBASE, BD.SGBASE, CO.CDTPCIA, DE.CDPURCHASEORDER UNION ALL SELECT 'H' || DE.CDFILIAL || '20' || '20' || LPAD(TO_CHAR(NVL(DE.NRDELEMISS, '0')),35,'0') || RPAD(CO.SGCIA,5,' ') || RPAD(DE.NRVOO,5,' ') || TO_CHAR(DE.DTHRPLAVOOPV, 'DDMMYYYY') || RPAD(:P_CDCIA, 10,' ') || RPAD(:P_CDCIA, 10,' ') || NVL(TO_CHAR(DE.DTEMISDEL, 'DDMMYYYY'),'00000000') || LPAD(TRUNC(NVL(DE.VRPETXAERO,0)),3,0) || LPAD((ROUND((NVL(DE.VRPETXAERO,0) - TRUNC(NVL(DE.VRPETXAERO,0))),2))*100,2,0) || LPAD(TRUNC(DECODE(DE.IDTIPNACDEL,1,NVL(DE.VRTXAEROR,0),NVL(DE.VRTXAEROD,0))),11,0) || LPAD((ROUND((DECODE(DE.IDTIPNACDEL,1,NVL(DE.VRTXAEROR,0),NVL(DE.VRTXAEROD,0)) - TRUNC(DECODE(DE.IDTIPNACDEL,1,NVL(DE.VRTXAEROR,0),NVL(DE.VRTXAEROD,0)))),2))*100,2,0) || LPAD(COUNT(SE.NRITEMPLANSP),5,'0') || RPAD(EQ.SGEQUIP,15,' ') || RPAD(BO.SGBASE || '-' || BD.SGBASE, 7, ' ') || MAX(SUBSTR(INDICADOR_TIPO_VOO_DELIVERY(DE.CDFILIAL, DE.CDCIA, DE.NRVOO, DE.CDTRECHO, PV.SGPREFIXO, PV.CDEQUIP, DE.NRDELIVERY, DE.DTHRPLAVOOPV, DE.NRORG), 1, 1 )) || LPAD(CO.CDTPCIA, 10, ' ') || LPAD(NVL(DE.CDPURCHASEORDER, '0'), 12, '0') AS CAMPOUNICO, DE.CDFILIAL, DE.NRDELIVERY, 0 AS ORDEM FROM DELIVERYM DE INNER JOIN PLANOVOOM PV ON PV.CDFILIAL = DE.CDFILIAL AND PV.CDCIA = DE.CDCIA AND PV.NRVOO = DE.NRVOO AND PV.CDTRECHO = DE.CDTRECHO AND PV.DTHRPLAVOOPV = DE.DTHRPLAVOOPV INNER JOIN SERVPLANOM SE ON SE.CDFILIAL = DE.CDFILIAL AND SE.NRDELIVERY = DE.NRDELIVERY INNER JOIN COMPANHIA CO ON CO.CDCIA = DE.CDCIA INNER JOIN EQUIPAMENTO EQ ON EQ.CDEQUIP = PV.CDEQUIP INNER JOIN VOOTRECHO VT ON VT.CDFILIAL = DE.CDFILIAL AND VT.CDCIA = DE.CDCIA AND VT.NRVOO = DE.NRVOO AND VT.CDTRECHO = DE.CDTRECHO INNER JOIN BASE BO ON BO.CDBASE = VT.CDBASEORI INNER JOIN BASE BD ON BD.CDBASE = VT.CDBASEDES INNER JOIN VOO VO ON VO.CDFILIAL = DE.CDFILIAL AND VO.CDCIA = DE.CDCIA AND VO.NRVOO = DE.NRVOO INNER JOIN LISTA L ON L.NRLISTA = :P_NRLISTA AND DE.NRVOO ||DE.CDTRECHO = L.CDLISTA WHERE (DE.CDFILIAL = :P_CDFILIAL) AND (DE.CDCIA = :P_CDCIA ) AND (DE.DTEMISDEL BETWEEN :P_DTINI AND :P_DTFIN) AND (DE.IDDELIEXPSAP = '$exportIDDELIEXPSAP') AND (DE.IDSITDEL <> '3') AND (SE.IDSITSERSP <> '3') AND (DE.CDFILIAL = '0013') GROUP BY DE.NRDELIVERY, DE.NRDELEMISS, DE.DTHRPLAVOOPV, TO_CHAR(DE.DTEMISDEL, 'DDMMYYYY'), DE.VRPETXAERO, DE.VRTXAEROR, DE.VRTXAEROD, DE.IDTIPNACDEL, DE.CDFILIAL, CO.SGCIA, DE.NRVOO, EQ.SGEQUIP, BO.SGBASE, BD.SGBASE, CO.CDTPCIA, DE.CDPURCHASEORDER UNION ALL SELECT 'I' || LPAD(SE.NRDELIVERY,35,0) || LPAD(SE.NRITEMPLANSP,5,0) || RPAD(SUBSTR(SCL.CDINTEGRASAP,1, 18),18,' ') || LPAD(TRUNC(NVL(SE.QTSERFATSP,0)),15,0) || LPAD(ROUND(NVL(SE.QTSERFATSP, 0) - TRUNC(NVL(SE.QTSERFATSP, 0)),3)*1000,3,0) || RPAD(SG.SGUNIDADE,2,' ') || LPAD(TRUNC(DECODE(SE.IDTIPMANUALSP,1,NVL(VRPRURESESP, 0), NVL(VRPRUDOLSESP, 0))),11,0) || LPAD(ROUND(DECODE(SE.IDTIPMANUALSP,1,NVL(VRPRURESESP, 0) -TRUNC(NVL(VRPRURESESP, 0)), NVL(VRPRUDOLSESP, 0) - TRUNC( NVL(VRPRUDOLSESP, 0) )),4)*10000,4,0) || DECODE(SE.IDTIPMANUALSP,1,LPAD(TRUNC(NVL(VRDESCRESESP,0) + NVL(VRDESCONDRSP,0) + NVL(VRDESFIXORSP,0)),9,0) || LPAD(ROUND(NVL(VRDESCRESESP,0) + NVL(VRDESCONDRSP,0) + NVL(VRDESFIXORSP,0) - TRUNC(NVL(VRDESCRESESP,0) + NVL(VRDESCONDRSP,0) + NVL(VRDESFIXORSP,0) ),4)*10000,4,0), LPAD(TRUNC(NVL(VRDESCDOSESP,0) + NVL(VRDESCONDDSP,0) + NVL(VRDESFIXODSP,0)),9,0) || LPAD(ROUND(NVL(VRDESCDOSESP,0) + NVL(VRDESCONDDSP,0) + NVL(VRDESFIXODSP,0) - TRUNC(NVL(VRDESCDOSESP,0) + NVL(VRDESCONDDSP,0) + NVL(VRDESFIXODSP,0) ),4)*10000,4,0)) || RPAD(NVL(ID.SGINDICE, ' '),3,' ') || :P_CDFILIAL || LPAD(TRUNC(QTATUAPRODSP),15,0) || LPAD(ROUND(NVL(QTATUAPRODSP, 0)-TRUNC( NVL(QTATUAPRODSP, 0) ),3)*1000,3,0) || LPAD(ROUND(NVL(QTREALPROD, 0) -TRUNC( NVL(QTREALPROD, 0)),3)*1000,0,0) || LPAD(NVL(SE.QTSESBYUTSP, 0),2,0) || LPAD(TRUNC(DECODE(NVL(SE.VRDESCPROP,0), 0, NVL(SE.VRPRUSBYSP*(CF.VRPERSBYUT/100),0), NVL(SE.VRPRUSBYSP,0) )),9,0) || LPAD(ROUND(DECODE(NVL(SE.VRDESCPROP,0), 0, NVL(SE.VRPRUSBYSP*(CF.VRPERSBYUT/100),0), SE.VRPRUSBYSP)-TRUNC(DECODE(NVL(SE.VRDESCPROP,0), 0, NVL(SE.VRPRUSBYSP*(CF.VRPERSBYUT/100),0), NVL(SE.VRPRUSBYSP, 0) )),4)*10000,4,0) || LPAD((NVL(SE.QTSESBYPRSP, 0) -NVL(SE.QTSESBYUTSP, 0) ),2,0) || LPAD(TRUNC(DECODE(NVL(SE.VRNUSADO,0), 0, NVL(SE.VRPRUSBYSP *(CF.VRPERSBYNUT/100),0), NVL(SE.VRNUSADO/NVL((SE.QTSESBYPRSP-SE.QTSESBYUTSP),1),0))),9,0) || LPAD(ROUND(DECODE(NVL(SE.VRNUSADO,0), 0, NVL(SE.VRPRUSBYSP *(CF.VRPERSBYNUT/100),0), NVL(SE.VRNUSADO /NVL((SE.QTSESBYPRSP-SE.QTSESBYUTSP),1),0))-TRUNC(DECODE(NVL(SE.VRNUSADO,0), 0, NVL(SE.VRPRUSBYSP*(CF.VRPERSBYNUT/100),0), NVL(SE.VRNUSADO/ NVL((SE.QTSESBYPRSP-SE.QTSESBYUTSP),1),0))),4)*10000,4,0) || DECODE(SE.IDTPPRECOSP,'1',' ','X') || DECODE(SE.IDTIPMANUALSP,1,DECODE(INSTR(VRDESDESVRSP,'-'),0,LPAD(TRUNC(VRDESDESVRSP),9,0) ||LPAD(ROUND(VRDESDESVRSP-TRUNC(VRDESDESVRSP),4)*10000,4,0),'-' ||LPAD(ABS(TRUNC(NVL(VRDESDESVRSP, 0) )),8,0) ||LPAD(ABS(ROUND( NVL(VRDESDESVRSP, 0) -TRUNC(NVL(VRDESDESVRSP, 0) ),4))*10000,4,0)), DECODE(INSTR(NVL(VRDESDESVDSP, 0),'-'),0,LPAD(TRUNC( NVL(VRDESDESVDSP, 0)),9,0) ||LPAD(ROUND( NVL(VRDESDESVDSP, 0) -TRUNC(NVL(VRDESDESVDSP,0) ),4)*10000,4,0),'-' ||LPAD(ABS(TRUNC( NVL(VRDESDESVDSP, 0) )),8,0) ||LPAD(ABS(ROUND( NVL(VRDESDESVDSP, 0)-TRUNC( NVL(VRDESDESVDSP,0) ),4))*10000,4,0))) || LPAD(NVL(SE.CDSEQPURCHASEORDER, '0'), 6, '0') || LPAD(NVL(DE.CDPURCHASEORDER, '0'), 12, '0') AS CAMPOUNICO, DE.CDFILIAL, DE.NRDELIVERY, 1 AS ORDEM FROM SERVPLANOM SE INNER JOIN DELIVERYM DE ON DE.CDFILIAL = SE.CDFILIAL AND DE.NRDELIVERY = SE.NRDELIVERY INNER JOIN LISTA L ON L.NRLISTA = :P_NRLISTA AND DE.NRVOO ||DE.CDTRECHO = L.CDLISTA INNER JOIN SERVCICLO SCL ON SCL.CDFILIAL = SE.CDFILIAL AND SCL.CDCIA = SE.CDCIA AND SCL.NRSERVICOCIAFILI = SE.NRSERVICOCIAFILI AND SCL.CDCICLO = SE.CDCICLO AND SCL.CDCLASSE = SE.CDCLASSE INNER JOIN SERVICOCIAFILI SCF ON SCF.CDFILIAL = SCL.CDFILIAL AND SCF.CDCIA = SCL.CDCIA AND SCF.NRSERVICOCIAFILI = SCL.NRSERVICOCIAFILI INNER JOIN SERVICOGEN SG ON SG.NRSERVICOGEN = SCF.NRSERVICOGEN INNER JOIN CIAFILI CF ON CF.CDFILIAL = SE.CDFILIAL AND CF.CDCIA = SE.CDCIA LEFT JOIN INDICE ID ON ID.CDTPINDICE = CF.CDTPINDICE AND ID.IDPERVALOR = CF.IDPERVALOR AND ID.CDINDICE = CF.CDINDICE WHERE (DE.CDFILIAL = :P_CDFILIAL) AND (DE.CDCIA = :P_CDCIA ) AND (DE.DTEMISDEL BETWEEN :P_DTINI AND :P_DTFIN) AND (DE.IDDELIEXPSAP = '$exportIDDELIEXPSAP') AND (DE.IDSITDEL <> '3') AND (SE.IDSITSERSP <> '3') AND (DE.CDFILIAL NOT IN ( '0014', '0013')) UNION ALL SELECT 'I' || LPAD(TO_CHAR(NVL(DE.NRDELEMISS, '0')),35,'0') || LPAD(SE.NRITEMPLANSP,5,0) || RPAD(SUBSTR(SCL.CDINTEGRASAP,1, 18),18,' ') || LPAD(TRUNC(NVL(SE.QTSERFATSP,0)),15,0) || LPAD(ROUND(NVL(SE.QTSERFATSP, 0) - TRUNC(NVL(SE.QTSERFATSP, 0)),3)*1000,3,0) || RPAD(SG.SGUNIDADE,2,' ') || LPAD(TRUNC(DECODE(SE.IDTIPMANUALSP,1,NVL(VRPRURESESP, 0), NVL(VRPRUDOLSESP, 0))),13,0) || LPAD(ROUND(DECODE(SE.IDTIPMANUALSP,1, NVL(VRPRURESESP, 0) -TRUNC( NVL(VRPRURESESP, 0) ), NVL(VRPRUDOLSESP, 0) - TRUNC( NVL(VRPRUDOLSESP, 0))),4)*100,2,0) || LPAD(0,13,0) || CASE ID.SGINDICE WHEN 'US$' THEN 'USD' WHEN 'US_M' THEN 'USD' WHEN 'US_Q' THEN 'USD' WHEN 'US_1' THEN 'USD' WHEN 'US_LH' THEN 'USD' WHEN 'P$' THEN 'ARS' ELSE RPAD(ID.SGINDICE,3,' ') END || :P_CDFILIAL || LPAD(TRUNC(QTATUAPRODSP),15,0) || LPAD(ROUND(NVL(QTATUAPRODSP, 0)-TRUNC( NVL(QTATUAPRODSP, 0) ),3)*1000,3,0) || LPAD(ROUND(NVL(QTREALPROD, 0) -TRUNC( NVL(QTREALPROD, 0)),3)*1000,0,0) || LPAD(NVL(SE.QTSESBYUTSP, 0),2,0) || LPAD(TRUNC(DECODE(NVL(SE.VRDESCPROP,0), 0, NVL(SE.VRPRUSBYSP*(CF.VRPERSBYUT/100),0), NVL(SE.VRPRUSBYSP,0) )),9,0) || LPAD(ROUND(DECODE(NVL(SE.VRDESCPROP,0), 0, NVL(SE.VRPRUSBYSP*(CF.VRPERSBYUT/100),0), SE.VRPRUSBYSP)-TRUNC(DECODE(NVL(SE.VRDESCPROP,0), 0, NVL(SE.VRPRUSBYSP*(CF.VRPERSBYUT/100),0), NVL(SE.VRPRUSBYSP, 0) )),4)*10000,4,0) || LPAD((NVL(SE.QTSESBYPRSP, 0) -NVL(SE.QTSESBYUTSP, 0) ),2,0) || LPAD(TRUNC(DECODE(NVL(SE.VRNUSADO,0), 0, NVL(SE.VRPRUSBYSP *(CF.VRPERSBYNUT/100),0), NVL(SE.VRNUSADO/NVL((SE.QTSESBYPRSP-SE.QTSESBYUTSP),1),0))),9,0) || LPAD(ROUND(DECODE(NVL(SE.VRNUSADO,0), 0, NVL(SE.VRPRUSBYSP *(CF.VRPERSBYNUT/100),0), NVL(SE.VRNUSADO /NVL((SE.QTSESBYPRSP-SE.QTSESBYUTSP),1),0))-TRUNC(DECODE(NVL(SE.VRNUSADO,0), 0, NVL(SE.VRPRUSBYSP*(CF.VRPERSBYNUT/100),0), NVL(SE.VRNUSADO/ NVL((SE.QTSESBYPRSP-SE.QTSESBYUTSP),1),0))),4)*10000,4,0) || DECODE(SE.IDTPPRECOSP,'1',' ','X') || DECODE(SE.IDTIPMANUALSP,1,DECODE(INSTR(VRDESDESVRSP,'-'),0,LPAD(TRUNC(VRDESDESVRSP),9,0) ||LPAD(ROUND(VRDESDESVRSP-TRUNC(VRDESDESVRSP),4)*10000,4,0),'-' ||LPAD(ABS(TRUNC(NVL(VRDESDESVRSP, 0) )),8,0) ||LPAD(ABS(ROUND( NVL(VRDESDESVRSP, 0) -TRUNC(NVL(VRDESDESVRSP, 0) ),4))*10000,4,0)), DECODE(INSTR(NVL(VRDESDESVDSP, 0),'-'),0,LPAD(TRUNC( NVL(VRDESDESVDSP, 0)),9,0) ||LPAD(ROUND( NVL(VRDESDESVDSP, 0) -TRUNC(NVL(VRDESDESVDSP,0) ),4)*10000,4,0),'-' ||LPAD(ABS(TRUNC( NVL(VRDESDESVDSP, 0) )),8,0) ||LPAD(ABS(ROUND( NVL(VRDESDESVDSP, 0)-TRUNC( NVL(VRDESDESVDSP,0) ),4))*10000,4,0))) || LPAD(NVL(SE.CDSEQPURCHASEORDER, '0'), 6, '0') || LPAD(NVL(DE.CDPURCHASEORDER, '0'), 12, '0') AS CAMPOUNICO, DE.CDFILIAL, DE.NRDELIVERY, 1 AS ORDEM FROM SERVPLANOM SE INNER JOIN DELIVERYM DE ON DE.CDFILIAL = SE.CDFILIAL AND DE.NRDELIVERY = SE.NRDELIVERY INNER JOIN LISTA L ON L.NRLISTA = :P_NRLISTA AND DE.NRVOO ||DE.CDTRECHO = L.CDLISTA INNER JOIN SERVCICLO SCL ON SCL.CDFILIAL = SE.CDFILIAL AND SCL.CDCIA = SE.CDCIA AND SCL.NRSERVICOCIAFILI = SE.NRSERVICOCIAFILI AND SCL.CDCICLO = SE.CDCICLO AND SCL.CDCLASSE = SE.CDCLASSE INNER JOIN SERVICOCIAFILI SCF ON SCF.CDFILIAL = SCL.CDFILIAL AND SCF.CDCIA = SCL.CDCIA AND SCF.NRSERVICOCIAFILI = SCL.NRSERVICOCIAFILI INNER JOIN SERVICOGEN SG ON SG.NRSERVICOGEN = SCF.NRSERVICOGEN INNER JOIN CIAFILI CF ON CF.CDFILIAL = SE.CDFILIAL AND CF.CDCIA = SE.CDCIA LEFT JOIN INDICE ID ON ID.CDTPINDICE = CF.CDTPINDICE AND ID.IDPERVALOR = CF.IDPERVALOR AND ID.CDINDICE = CF.CDINDICE WHERE (DE.CDFILIAL = :P_CDFILIAL) AND (DE.CDCIA = :P_CDCIA ) AND (DE.DTEMISDEL BETWEEN :P_DTINI AND :P_DTFIN) AND (DE.IDDELIEXPSAP = '$exportIDDELIEXPSAP') AND (DE.IDSITDEL <> '3') AND (SE.IDSITSERSP <> '3') AND (DE.CDFILIAL = '0013') UNION ALL SELECT 'I' || LPAD(DE.NRDELIVERYFA,35,0) || LPAD(SE.NRITEMPLANSP,5,0) || RPAD(SUBSTR(SCL.CDINTEGRASAP,1, 18),18,' ') || LPAD(TRUNC(NVL(SE.QTSERFATSP,0)),15,0) || LPAD(ROUND(NVL(SE.QTSERFATSP, 0) - TRUNC(NVL(SE.QTSERFATSP, 0)),3)*1000,3,0) || RPAD(SG.SGUNIDADE,2,' ') || LPAD(TRUNC(DECODE(SE.IDTIPMANUALSP,1,NVL(VRPRURESESP, 0), NVL(VRPRUDOLSESP, 0))),11,0) || LPAD(ROUND(DECODE(SE.IDTIPMANUALSP,1,NVL(VRPRURESESP, 0) -TRUNC(NVL(VRPRURESESP, 0)), NVL(VRPRUDOLSESP, 0) - TRUNC( NVL(VRPRUDOLSESP, 0) )),4)*10000,4,0) || DECODE(SE.IDTIPMANUALSP,1,LPAD(TRUNC(NVL(VRDESCRESESP,0) + NVL(VRDESCONDRSP,0) + NVL(VRDESFIXORSP,0)),9,0) ||LPAD(ROUND(NVL(VRDESCRESESP,0) + NVL(VRDESCONDRSP,0) + NVL(VRDESFIXORSP,0) - TRUNC(NVL(VRDESCRESESP,0) + NVL(VRDESCONDRSP,0) + NVL(VRDESFIXORSP,0) ),4)*10000,4,0), LPAD(TRUNC(NVL(VRDESCDOSESP,0) + NVL(VRDESCONDDSP,0) + NVL(VRDESFIXODSP,0)),9,0) ||LPAD(ROUND(NVL(VRDESCDOSESP,0) + NVL(VRDESCONDDSP,0) + NVL(VRDESFIXODSP,0) - TRUNC(NVL(VRDESCDOSESP,0) + NVL(VRDESCONDDSP,0) + NVL(VRDESFIXODSP,0) ),4)*10000,4,0)) || CASE DE.CDFILIAL ||ID.SGINDICE WHEN '0014P$' THEN 'CLP' WHEN '0014US$' THEN 'USD' ELSE RPAD(ID.SGINDICE,3,' ') END || :P_CDFILIAL || LPAD(TRUNC(QTATUAPRODSP),15,0) || LPAD(ROUND(NVL(QTATUAPRODSP, 0)-TRUNC( NVL(QTATUAPRODSP, 0) ),3)*1000,3,0) || LPAD(ROUND(NVL(QTREALPROD, 0) -TRUNC( NVL(QTREALPROD, 0)),3)*1000,0,0) || LPAD(NVL(SE.QTSESBYUTSP, 0),2,0) || LPAD(TRUNC(DECODE(NVL(SE.VRDESCPROP,0), 0, NVL(SE.VRPRUSBYSP*(CF.VRPERSBYUT/100),0), NVL(SE.VRPRUSBYSP,0) )),9,0) || LPAD(ROUND(DECODE(NVL(SE.VRDESCPROP,0), 0, NVL(SE.VRPRUSBYSP*(CF.VRPERSBYUT/100),0), SE.VRPRUSBYSP)-TRUNC(DECODE(NVL(SE.VRDESCPROP,0), 0, NVL(SE.VRPRUSBYSP*(CF.VRPERSBYUT/100),0), NVL(SE.VRPRUSBYSP, 0) )),4)*10000,4,0) || LPAD((NVL(SE.QTSESBYPRSP, 0) -NVL(SE.QTSESBYUTSP, 0) ),2,0) || LPAD(TRUNC(DECODE(NVL(SE.VRNUSADO,0), 0, NVL(SE.VRPRUSBYSP *(CF.VRPERSBYNUT/100),0), NVL(SE.VRNUSADO/NVL((SE.QTSESBYPRSP-SE.QTSESBYUTSP),1),0))),9,0) || LPAD(ROUND(DECODE(NVL(SE.VRNUSADO,0), 0, NVL(SE.VRPRUSBYSP *(CF.VRPERSBYNUT/100),0), NVL(SE.VRNUSADO /NVL((SE.QTSESBYPRSP-SE.QTSESBYUTSP),1),0))-TRUNC(DECODE(NVL(SE.VRNUSADO,0), 0, NVL(SE.VRPRUSBYSP*(CF.VRPERSBYNUT/100),0), NVL(SE.VRNUSADO/ NVL((SE.QTSESBYPRSP-SE.QTSESBYUTSP),1),0))),4)*10000,4,0) || DECODE(SE.IDTPPRECOSP,'1',' ','X') || DECODE(SE.IDTIPMANUALSP,1,DECODE(INSTR(VRDESDESVRSP,'-'),0,LPAD(TRUNC(VRDESDESVRSP),9,0) ||LPAD(ROUND(VRDESDESVRSP-TRUNC(VRDESDESVRSP),4)*10000,4,0),'-' ||LPAD(ABS(TRUNC(NVL(VRDESDESVRSP, 0) )),8,0) ||LPAD(ABS(ROUND( NVL(VRDESDESVRSP, 0) -TRUNC(NVL(VRDESDESVRSP, 0) ),4))*10000,4,0)), DECODE(INSTR(NVL(VRDESDESVDSP, 0),'-'),0,LPAD(TRUNC( NVL(VRDESDESVDSP, 0)),9,0) ||LPAD(ROUND( NVL(VRDESDESVDSP, 0) -TRUNC(NVL(VRDESDESVDSP,0) ),4)*10000,4,0),'-' ||LPAD(ABS(TRUNC( NVL(VRDESDESVDSP, 0) )),8,0) ||LPAD(ABS(ROUND( NVL(VRDESDESVDSP, 0)-TRUNC( NVL(VRDESDESVDSP,0) ),4))*10000,4,0))) || LPAD(NVL(SE.CDSEQPURCHASEORDER, '0'), 6, '0') || LPAD(NVL(DE.CDPURCHASEORDER, '0'), 12, '0') AS CAMPOUNICO, DE.CDFILIAL, DE.NRDELIVERY, 1 AS ORDEM FROM SERVPLANOM SE INNER JOIN DELIVERYM DE ON DE.CDFILIAL = SE.CDFILIAL AND DE.NRDELIVERY = SE.NRDELIVERY INNER JOIN LISTA L ON L.NRLISTA = :P_NRLISTA AND DE.NRVOO ||DE.CDTRECHO = L.CDLISTA INNER JOIN SERVCICLO SCL ON SCL.CDFILIAL = SE.CDFILIAL AND SCL.CDCIA = SE.CDCIA AND SCL.NRSERVICOCIAFILI = SE.NRSERVICOCIAFILI AND SCL.CDCICLO = SE.CDCICLO AND SCL.CDCLASSE = SE.CDCLASSE INNER JOIN SERVICOCIAFILI SCF ON SCF.CDFILIAL = SCL.CDFILIAL AND SCF.CDCIA = SCL.CDCIA AND SCF.NRSERVICOCIAFILI = SCL.NRSERVICOCIAFILI INNER JOIN SERVICOGEN SG ON SG.NRSERVICOGEN = SCF.NRSERVICOGEN INNER JOIN CIAFILI CF ON CF.CDFILIAL = SE.CDFILIAL AND CF.CDCIA = SE.CDCIA LEFT JOIN INDICE ID ON ID.CDTPINDICE = CF.CDTPINDICE AND ID.IDPERVALOR = CF.IDPERVALOR AND ID.CDINDICE = CF.CDINDICE WHERE (DE.CDFILIAL = :P_CDFILIAL) AND (DE.CDCIA = :P_CDCIA ) AND (DE.DTEMISDEL BETWEEN :P_DTINI AND :P_DTFIN) AND (DE.IDDELIEXPSAP = '$exportIDDELIEXPSAP') AND (DE.IDSITDEL <> '3') AND (SE.IDSITSERSP <> '3') AND (DE.CDFILIAL = '0014') ORDER BY CDFILIAL, NRDELIVERY, ORDEM", $params);
		return $rows;
	}

	public function findArquivoServico($cdfilial, $nrorg, $id, $cdcia, $dtultatu, $servico) {
		if($dtultatu == "null" || $dtultatu == "")
			$dtultatu = null;
		if ($id == '0')
			$sql = "SELECT DISTINCT S.CDFILIAL || '20' || '20' || S.CDFILIAL || S.CDFILIAL || RPAD(SC.CDINTEGRASAP, 18, ' ') || RPAD(DECODE(SG.SGUNIDADE, 'LT', 'L', NVL(SG.SGUNIDADE, ' ')), 2, ' ') || LPAD(TRUNC(NVL(SC.VRPESOSE, 0)), 13, 0) || LPAD(ROUND(NVL(SC.VRPESOSE - TRUNC(SC.VRPESOSE), 0), 3)*1000, 3, 0) || LPAD(TRUNC(NVL(SC.VRPESOSE, 0)), 13, 0) || LPAD(ROUND(NVL(SC.VRPESOSE - TRUNC(SC.VRPESOSE), 0), 3)*1000, 3, 0) || DECODE(S.CDFILIAL, '4341', 'LB', 'KG') || ' ' || CASE WHEN SG.IDSERVICO = '3' THEN '2' ELSE '1' END || DECODE(CL.SGCLASSE, 'F/C', 'C01', 'ESPFC', 'C01', 'B/C', 'C02', 'ESPBC', 'C02', 'Y/C', 'C03', 'ESPYC', 'C03', 'T/C', 'C04', 'T/T', 'C04', 'HAND', 'C05', 'MISC', 'C99') || DECODE(CL.SGCLASSE, 'F/C', 'C01', 'ESPFC', 'C01', 'B/C', 'C02', 'ESPBC', 'C02', 'Y/C', 'C03', 'ESPYC', 'C03', 'T/C', 'C04', 'T/T', 'C04', 'HAND', 'C05', 'MISC', 'C99') || ' ' || RPAD(NVL(TRANSLATE(S.DSSERVICOCIAFILIING, 'ÁÉÍÓÚÀÈÌÒÙÂÊÎÔÛÄËÏÖÜÃÕÑÇ—', 'AEIOUAEIOUAEIOUAEIOUAONC'), ' '), 40, ' ') || RPAD(NVL(TRANSLATE(S.DSSERVICOCIAFILIESP, 'ÁÉÍÓÚÀÈÌÒÙÂÊÎÔÛÄËÏÖÜÃÕÑÇ—', 'AEIOUAEIOUAEIOUAEIOUAONC'), ' '), 40, ' ') || RPAD(NVL(TRANSLATE(NVL(SC.NMINTEGRACAO, S.DSSERVICOCIAFILI), 'ÁÉÍÓÚÀÈÌÒÙÂÊÎÔÛÄËÏÖÜÃÕÑÇ—', 'AEIOUAEIOUAEIOUAEIOUAONC'), ' '), 40, ' ') || ' ' || NVL(TO_CHAR(SC.DTULTATU, 'DDMMYYYY'), '00000000') || RPAD(NVL(P.SGPADSERV, ' '), 8, ' ') AS CAMPOUNICO, SC.CDINTEGRASAP FROM SERVCICLO SC INNER JOIN SERVICOCIAFILI S ON S.CDFILIAL = SC.CDFILIAL AND S.CDCIA = SC.CDCIA AND S.NRSERVICOCIAFILI = SC.NRSERVICOCIAFILI INNER JOIN SERVICOGEN SG ON SG.NRSERVICOGEN = S.NRSERVICOGEN INNER JOIN PADSERVICOM P ON P.NRPADSERVICOM = S.NRPADSERVICOM INNER JOIN CLASSE CL ON CL.CDCLASSE = SC.CDCLASSE WHERE SC.CDFILIAL = :P_CDFILIAL AND( INSTR(:P_CDCIA,SC.CDCIA) > 0 OR :P_CDCIA = 'T') AND( SC.DTULTATU >= :P_DTULTATU OR :P_DTULTATU IS NULL) AND S.IDTIPOSERVICO <> 'ITEMMENUGRID' AND( INSTR(:SERVICO,'_' ||SC.CDFILIAL ||SC.CDCIA ||SC.NRSERVICOCIAFILI ||SC.CDCLASSE ||SC.CDCICLO ||'_') <>0 OR :SERVICO = 'T' ) AND SC.NRORG = :P_NRORG ORDER BY SC.CDINTEGRASAP";
		else if($id == '1'){
			$sql = "SELECT DISTINCT S.CDFILIAL || '20' || '20' || S.CDFILIAL || S.CDFILIAL || RPAD(SC.CDINTEGRASAP, 18, ' ') || RPAD(DECODE(SG.SGUNIDADE,'LT','L', NVL(SG.SGUNIDADE,' ')),2,' ') || LPAD(TRUNC(NVL(SC.VRPESOSE,0)), 13,0) ||LPAD(ROUND(NVL(SC.VRPESOSE - TRUNC(SC.VRPESOSE),0),3)*1000, 3,0) || LPAD(TRUNC(NVL(SC.VRPESOSE,0)), 13,0) ||LPAD(ROUND(NVL(SC.VRPESOSE - TRUNC(SC.VRPESOSE),0),3)*1000, 3,0) || DECODE(S.CDFILIAL,'4341','LB','KG') || RPAD(' ', 9, ' ') || CASE WHEN SG.IDSERVICO = '3' THEN '2' ELSE '1' END || CASE CL.SGCLASSE WHEN 'F/C' THEN 'C01' WHEN 'ESPFC' THEN 'C01' WHEN 'B/C' THEN 'C02' WHEN 'ESPBC' THEN 'C02' WHEN 'Y/C' THEN 'C03' WHEN 'ESPYC' THEN 'C03' WHEN 'T/C' THEN 'C04' WHEN 'T/T' THEN 'C04' WHEN 'HAND' THEN 'C05' WHEN 'VP' THEN 'C06' WHEN 'MISC' THEN 'C99' WHEN 'Y/CPL' THEN 'C07' WHEN 'BC' THEN 'C02' WHEN 'CREW' THEN 'C04' WHEN 'FA' THEN 'C04' WHEN 'FC' THEN 'C01' WHEN 'H' THEN 'C05' WHEN 'LAV' THEN 'C05' WHEN 'MISBC' THEN 'C99' WHEN 'MISC' THEN 'C99' WHEN 'MISFC' THEN 'C99' WHEN 'MISYC' THEN 'C99' WHEN 'WYC' THEN 'C07' WHEN 'YC' THEN 'C03' WHEN 'AP' THEN 'C99' WHEN 'BC' THEN 'C02' WHEN 'CW' THEN 'C04' WHEN 'DS' THEN 'C99' WHEN 'EY' THEN 'C07' WHEN 'FC' THEN 'C01' WHEN 'FOOD' THEN 'C03' WHEN 'HAND' THEN 'C05' WHEN 'LV' THEN 'C99' WHEN 'MS' THEN 'C99' WHEN 'SEBC' THEN 'C02' WHEN 'SECW' THEN 'C04' WHEN 'SEFC' THEN 'C01' WHEN 'SERV' THEN 'C05' WHEN 'SEYC' THEN 'C03' WHEN 'STBY' THEN 'C03' WHEN 'VALES' THEN 'C03' WHEN 'XC' THEN 'C08' WHEN 'YC' THEN 'C03' WHEN 'PORTF' THEN 'C99' WHEN 'MEDIA' THEN RPAD(' ', 3, ' ') WHEN 'TLD01' THEN RPAD(' ', 3, ' ') WHEN 'BASIC' THEN RPAD(' ', 3, ' ') WHEN 'TLD02' THEN RPAD(' ', 3, ' ') WHEN 'TRANS' THEN RPAD(' ', 3, ' ') ELSE RPAD(' ', 3, ' ') END || DECODE(:P_CDFILIAL || SG.IDSERVICO, '00131','E01','00132','ZZZ', '00133','E03', '00021',RPAD(' ', 3, ' '),'00022',RPAD(' ', 3, ' '), '00023',RPAD(' ', 3, ' '), '00024', RPAD(' ', 3, ' '),'00025', RPAD(' ', 3, ' '),'00031',RPAD(' ', 3, ' '), '00032',RPAD(' ', 3, ' '), '00033',RPAD(' ', 3, ' '), '00121',RPAD(' ', 3, ' '), '00122',RPAD(' ', 3, ' '), '00123',RPAD(' ', 3, ' '), '00061',RPAD(' ', 3, ' '), '00062',RPAD(' ', 3, ' '), '00063',RPAD(' ', 3, ' '), '00111',RPAD(' ', 3, ' '), '00112',RPAD(' ', 3, ' '), '00113',RPAD(' ', 3, ' '), '00171',RPAD(' ', 3, ' '), '00172',RPAD(' ', 3, ' '), '00173',RPAD(' ', 3, ' '), '00181',RPAD(' ', 3, ' '), '00182',RPAD(' ', 3, ' '), '00183',RPAD(' ', 3, ' '), '00191',RPAD(' ', 3, ' '), '00192',RPAD(' ', 3, ' '), '00193',RPAD(' ', 3, ' '), '43411',RPAD(' ', 3, ' '), '43412',RPAD(' ', 3, ' '), '43413',RPAD(' ', 3, ' '), '00141','E01','00142','ZZZ', '00143','E03', '42911',RPAD(' ', 3, ' '),'42912',RPAD(' ', 3, ' '), '42913',RPAD(' ', 3, ' ')) || ' ' || RPAD(NVL(TRANSLATE(S.DSSERVICOCIAFILIING, 'ÁÉÍÓÚÀÈÌÒÙÂÊÎÔÛÄËÏÖÜÃÕÑÇ—', 'AEIOUAEIOUAEIOUAEIOUAONC'),' '),40,' ') || RPAD(NVL(TRANSLATE(S.DSSERVICOCIAFILIESP, 'ÁÉÍÓÚÀÈÌÒÙÂÊÎÔÛÄËÏÖÜÃÕÑÇ—', 'AEIOUAEIOUAEIOUAEIOUAONC'),' '),40,' ') || RPAD(NVL(TRANSLATE(NVL(SC.NMINTEGRACAO, S.DSSERVICOCIAFILI), 'ÁÉÍÓÚÀÈÌÒÙÂÊÎÔÛÄËÏÖÜÃÕÑÇ—', 'AEIOUAEIOUAEIOUAEIOUAONC'),' '),40,' ') || RPAD(' ', 2, ' ') || NVL(TO_CHAR(SC.DTULTATU, 'DDMMYYYY'),'00000000') AS CAMPOUNICO, SC.CDINTEGRASAP FROM SERVCICLO SC INNER JOIN SERVICOCIAFILI S ON S.CDFILIAL = SC.CDFILIAL AND S.CDCIA = SC.CDCIA AND S.NRSERVICOCIAFILI = SC.NRSERVICOCIAFILI INNER JOIN SERVICOGEN SG ON SG.NRSERVICOGEN = S.NRSERVICOGEN INNER JOIN PADSERVICOM P ON P.NRPADSERVICOM = S.NRPADSERVICOM INNER JOIN CLASSE CL ON CL.CDCLASSE = SC.CDCLASSE WHERE SC.CDFILIAL = :P_CDFILIAL AND (INSTR(:P_CDCIA,SC.CDCIA) > 0 OR :P_CDCIA = 'T') AND (SC.DTULTATU >= :P_DTULTATU OR :P_DTULTATU IS NULL) AND	 S.IDTIPOSERVICO <> 'ITEMMENUGRID' AND (INSTR(:SERVICO,'_' || SC.CDFILIAL || SC.CDCIA ||SC.NRSERVICOCIAFILI || SC.CDCLASSE || SC.CDCICLO ||'_') <>0 OR :SERVICO = 'T') AND SC.NRORG = :P_NRORG AND SC.CDFILIAL || CL.SGCLASSE NOT IN('0014BASIC','0014MEDIA','0014SERV','0014STBY','0014TLD01','0014TLD02','0014TRANS') ORDER BY SC.CDINTEGRASAP";
		}
		$stmt = $this->connection->prepare($sql);
		$stmt->execute(array(
			"P_CDFILIAL" => $cdfilial,
			"P_NRORG" => $nrorg,
			"SERVICO" => $servico,
			"P_CDCIA" => $cdcia,
			"P_DTULTATU" => $dtultatu
		));
		$result = $stmt->fetchAll(\PDO::FETCH_ASSOC);
		return $result;
	}
}